/*
 * Created on May 11, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.enhydra.dods.statistics;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class QueryCacheStatistics extends TableStatistics {

	/**
	 * Maximum cache size.
	 */
	protected int maxCacheSize;

	/**
	 * Current cache size.
	 */
	protected int cacheSize;

	/**
	 * Number of queries performed on the cache successfully.
	 */
	protected int cacheHitsNum;

	/**
	 * Number of query by OIds performed on the cache successfully.
	 */
	protected int cacheByOIdHitsNum;

    /**
     * Maximum simple query cache size.
     */
    protected int maxSimpleQueryCacheSize;

    /**
     * Current size of simple query cache.
     */
    protected int simpleQueryCacheSize;

    /**
     * Number of queries found in simple query cache. If query is found in 
     * simple query cache, the results are retrived from there.
     */
    protected int simpleCacheHitsNum;

    /**
      * Maximum complex query cache size.
      */
     protected int maxComplexQueryCacheSize;

     /**
      * Current size of complex query cache.
      */
     protected int complexQueryCacheSize;

     /**
      * Number of queries found in complex query cache. If query is found in 
      * complex query cache, the results are retrived from there.
      */
     protected int complexCacheHitsNum;


	/**
	 * Type of caching.
	 */
	protected String cacheType;

	/**
     * Constructor (String, String).
	 * @param name
	 */
	public QueryCacheStatistics(String name) {
		super(name);
		
	}

	/**
	 * Returns maximum cache size.
	 * @return maximum cache size
	 */
	public int getMaxCacheSize() {
		return maxCacheSize;
	}

	/**
	 * Sets maximum cache size.
	 * @param maxSize maximum cache size
	 */
	public void setMaxCacheSize(int maxSize) {
		maxCacheSize = maxSize;
	}

	/**
	 * Returns current cache size.
	 * @return current cache size
	 */
	public int getCacheSize() {
		return cacheSize;
	}

	/**
	 * Sets current cache size.
	 * @param size current cache size
	 */
	public void setCacheSize(int size) {
		cacheSize = size;
	}

	/**
	 * Returns number of queries performed on the cache successfully.
	 * @return number of queries performed on the cache successfully 
	 */
	public int getCacheHitsNum() {
		return cacheHitsNum;
	}

	/**
	 * Sets number of queries performed on the cache successfully.
	 * @param cacheHitsNum number of queries performed on the cache successfully
	 */
	public void setCacheHitsNum(int cacheHitsNum) {
		this.cacheHitsNum = cacheHitsNum;
	}

	/**
	 * Increases number of queries performed on the cache successfully for one.
	 */
	public void incrementCacheHitsNum() {
		cacheHitsNum++;
	}

	/**
	 * Returns number of query by OIds performed on the cache successfully.
	 * @return number of query by OIds performed on the cache successfully.
	 */
	public int getCacheByOIdHitsNum() {
		return cacheByOIdHitsNum;
	}

	/**
	 * Sets number of query by OIds performed on the cache successfully.
	 * @param cacheByOIdHitsNum number of query by OIds performed on the cache successfully.
	 */
	public void setCacheByOIdHitsNum(int cacheHitsNum) {
		this.cacheByOIdHitsNum = cacheByOIdHitsNum;
	}

	/**
	 * Increases number of query by OIds performed on the cache successfully for one.
	 */
	public void incrementCacheByOIdHitsNum() {
		cacheByOIdHitsNum++;
	}

	/**
	 * Returns how much cache is currently used. This value is given in percents.
	 * @return percents how much cache is currently used 
	 * Value -1 means that this cache doesn't have maximum cache size.
	 */
	public double getUsedPercents() {
		if (maxCacheSize == 0)
			return 0;
        if (maxCacheSize < 0)
            return -1;    
		int temp = cacheSize * 10000;
		double res = temp / maxCacheSize;
		return res / 100;
	}
    
    /**
     * Returns how much simple query cache is currently used. This value is 
     * given in percents.
     * @return percents how much simple query cache is currently used. 
     * Value -1 means that this cache doesn't have maximum cache size.
     */
    public double getSimpleUsedPercents() {
        if (maxSimpleQueryCacheSize == 0)
            return 0;
        if (maxSimpleQueryCacheSize < 0)
            return -1; 
        int temp = simpleQueryCacheSize * 10000;
        double res = temp / maxSimpleQueryCacheSize;
        return res / 100;
    }
    
    /**
     * Returns how much complex query cache is currently used. This value is 
     * given in percents.
     * @return percents how much complex query cache is currently used. 
     * Value -1 means that this cache doesn't have maximum cache size.
     */
    public double getComplexUsedPercents() {
        if (maxComplexQueryCacheSize == 0)
            return 0;
        if (maxComplexQueryCacheSize < 0)
            return -1; 
        int temp = complexQueryCacheSize * 10000;
        double res = temp / maxComplexQueryCacheSize;
        return res / 100;
    }

	/**
	 * Returns how much queries performed on the cache were successful. 
	 * This value is given in percents.
	 * @return percents how much queries performed on the cache were successful 
	 */
	public double getCacheHitsPercents() {
		if (queryNum == 0)
			return 0;
		int temp = cacheHitsNum * 10000;
		double res = temp / queryNum;
		return res / 100;
	}
	
    /**
     * Returns number of queries found in complex query cache. 
     * @return number of queries found in complex query cache.
     */
    public int getComplexCacheHitsNum() {
        return complexCacheHitsNum;
    }

    /**
     * Returns current size of complex query cache.
     * @return current size of complex query cache.
     */
    public int getComplexQueryCacheSize() {
        return complexQueryCacheSize;
    }

    /**
     * Returns maximum size of complex query cache.
     * @return maximum size of complex query cache.
     */
    public int getMaxComplexQueryCacheSize() {
        return maxComplexQueryCacheSize;
    }

    /**
     * Returns maximum size of simple query cache.
     * @return maximum size of simple query cache.
     */
    public int getMaxSimpleQueryCacheSize() {
        return maxSimpleQueryCacheSize;
    }

    /**
     * Returns number of queries found in simple query cache.
     * @return number of queries found in simple query cache.
     */
    public int getSimpleCacheHitsNum() {
        return simpleCacheHitsNum;
    }

    /**
     * Returns current size of complex query cache.
     * @return current size of complex query cache.
     */
    public int getSimpleQueryCacheSize() {
        return simpleQueryCacheSize;
    }

    /**
     * Sets number of queries found in complex query cache.  
     * @param num new number of queries found in complex query cache.
     */
    public void setComplexCacheHitsNum(int num) {
        complexCacheHitsNum = num;
    }

    /**
     * Sets current size of complex query cache.
     * @param size new current size of complex query cache.
     */
    public void setComplexQueryCacheSize(int size) {
        complexQueryCacheSize = size;
    }

    /**
     * Sets maximum size of complex query cache.
     * @param size new maximum size of complex query cache.
     */
    public void setMaxComplexQueryCacheSize(int size) {
        maxComplexQueryCacheSize = size;
    }

    /**
     * Sets maximum size of simple query cache.
     * @param size new maximum size of simple query cache.
     */
    public void setMaxSimpleQueryCacheSize(int size) {
        maxSimpleQueryCacheSize = size;
    } 

    /**
     * Sets number of queries found in simple query cache.
     * @param size new number of queries found in simple query cache.
     */
    public void setSimpleCacheHitsNum(int size) {
        simpleCacheHitsNum = size;
    }

    /**
     * Sets current size of simple query cache.
     * @param size new current size of simple query cache.
     */
    public void setSimpleQueryCacheSize(int size) {
        simpleQueryCacheSize = size;
    }
    
    /**
     * Increases number of queries found in simple query cache for one.
     */
    public void incrementSimpleCacheHitsNum() {
        simpleCacheHitsNum++;
    }
    
   /**
    * Increases number of queries found in complex query cache for one.
    */
   public void incrementComplexCacheHitsNum() {
       complexCacheHitsNum++;
   }
   
  /** 
   * Returns how much performed simple queries were found and used from simple 
   * query cache (compared to all simple queries). This value is given 
   * in percents.
   * 
   * @return percents of how much performed simple queries were found and used 
   * from simple query cache.
   */
  public double getSimpleQueryCacheHitsPercents() {
      if (simpleQueryNum == 0)
          return 0;
      int temp = simpleCacheHitsNum * 10000;
      double res = temp / simpleQueryNum;
      return res / 100;
  }
  
   /** 
     * Returns how much performed complex queries were found and used from 
     * complex query cache (compared to all complex queries). This value is 
     * given in percents.
     * 
     * @return percents of how much performed complex queries were found and 
     * used from complex query cache.
     */
    public double getComplexQueryCacheHitsPercents() {
        if (complexQueryNum == 0)
            return 0;
        int temp = complexCacheHitsNum * 10000;
        double res = temp / complexQueryNum;
        return res / 100;
    }
    
    /**
	 * Returns cache type.
	 * @return cache type
	 */
	public String getCacheType() {
		return cacheType;
	}

	/**
	 * Sets cache type.
	 * @param type cache type
	 */
	public void setCacheType(String type) {
		cacheType = type;
	}
    
    /**
     * Shows content of this class.  
     * Can be used for debugging.
     */
    public void show() {
        System.out.println("-------------------------------------------------");
        System.out.println("Table statistics for: " + tableName);
        System.out.println(" cacheType: " + cacheType);
        System.out.println(" maxCacheSize : " + maxCacheSize);
        System.out.println(" cacheSize : " + cacheSize);
        System.out.println(" maxSimpleQueryCacheSize : " + maxSimpleQueryCacheSize);
        System.out.println(" simpleQueryCacheSize : " + simpleQueryCacheSize);
        System.out.println(" simpleCacheHitsNum : " + simpleCacheHitsNum);
        System.out.println(" maxComplexQueryCacheSize : " + maxComplexQueryCacheSize);
        System.out.println(" complexQueryCacheSize : " + complexQueryCacheSize);
        System.out.println(" complexCacheHitsNum : " + complexCacheHitsNum);
        System.out.println(" queryNum : " + queryNum);
        System.out.println(" queryByOIdNum : " + queryByOIdNum);
        System.out.println(" cacheHitsNum : " + cacheHitsNum);
        System.out.println(" getUsedPercents : " + getUsedPercents());
        System.out.println(" getCacheHitsPercents : " + getCacheHitsPercents());
        System.out.println(" insertNum : " + insertNum);
        System.out.println(" updateNum : " + updateNum);
        System.out.println(" deleteNum : " + deleteNum);
        System.out.println(" lazyLoadingNum : " + lazyLoadingNum);
        System.out.println(" startTime : " + startTime);
        System.out.println(" stopTime : " + stopTime);
        System.out.println(" averageQueryTime : " + averageQueryTime);
        System.out.println(" averageQueryByOIdTime : " + averageQueryByOIdTime);
        System.out.println(" getSimpleQueryCacheHitsPercents : " + getSimpleQueryCacheHitsPercents());
        System.out.println(" getComplexQueryCacheHitsPercents : " + getComplexQueryCacheHitsPercents());
        System.out.println(" getSimpleUsedPercents : " + getSimpleUsedPercents());
        System.out.println(" getComplexUsedPercents : " + getComplexUsedPercents());
     }

}
