/*-----------------------------------------------------------------------------
 * Enhydra Java Application Server
 * Copyright 1997-2000 Lutris Technologies, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes Enhydra software developed by Lutris
 *      Technologies, Inc. and its contributors.
 * 4. Neither the name of Lutris Technologies nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY LUTRIS TECHNOLOGIES AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL LUTRIS TECHNOLOGIES OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 * 
 * contains WebDocWf extensions
 * 
 *-----------------------------------------------------------------------------
 * C:/develop/gen/org/webdocwf/util/genericstore/data/EnumValueDefinitionDO.java
 *-----------------------------------------------------------------------------
 */

package org.webdocwf.util.genericstore.data;

import java.math.BigDecimal;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Enumeration;
import java.util.Hashtable;

import org.enhydra.dods.DODS;
import org.webdocwf.dods.access.AccessEvalException;
import org.webdocwf.dods.access.AccessException;
import org.webdocwf.dods.access.AccessRightException;
import org.webdocwf.util.genericstore.GenericStoreDO;

import com.lutris.appserver.server.sql.CoreDO;
import com.lutris.appserver.server.sql.DBConnection;
import com.lutris.appserver.server.sql.DBRowUpdateException;
import com.lutris.appserver.server.sql.DBTransaction;
import com.lutris.appserver.server.sql.DatabaseManager;
import com.lutris.appserver.server.sql.DatabaseManagerException;
import com.lutris.appserver.server.sql.ObjectId;
import com.lutris.appserver.server.sql.ObjectIdException;
import com.lutris.dods.builder.generator.query.DataObjectException;
import com.lutris.dods.builder.generator.query.NonUniqueQueryException;
import com.lutris.dods.builder.generator.query.QueryException;
import com.lutris.dods.builder.generator.query.RDBColumn;
import com.lutris.dods.builder.generator.query.RDBColumnValue;
import com.lutris.dods.builder.generator.query.RDBRow;
import com.lutris.dods.builder.generator.query.RDBTable;
import com.lutris.dods.builder.generator.query.RefAssertionException;
// end of WebDocWf extension for DODS row instance security and genric store

/**
 * Data core class, used to set, retrieve the EnumValueDefinitionDO information.
 *
 * @version $Revision: 1.2 $
 * @author  administrator
 * @since   org
 */
 public class EnumValueDefinitionDO extends org.webdocwf.util.genericstore.GenericStoreDO implements EnumValueDefinitionDOI, java.io.Serializable {

    /**
     * static final data members name the table and columns for this DO.
     * By using these members with an instance of the QueryBuilder class,
     * an application can perform straight SQL queries while retaining
     * compile-time checking of table and column usage.
     *
     * Example:  List the Cities containing Persons named Bob:
     *
     *    Using straight SQL with QueryBuilder:
     *      Pro: code runs faster because you create fewer objects
     *      Con: code is less clear
     *
     *         Vector fields = new Vector();
     *         fields.addElement( AddressDO.City );
     *         QueryBuilder qb = new QueryBuilder( fields );
     *         qb.addWhere( PersonDO.FirstName, "Bob" );
     *         qb.addWhere( PersonDO.PrimaryKey, AddressDO.Person );
     *         RDBRow row;
     *         while ( null != ( row = qb.getNextRow() ) ) {
     *             String city = row.get( AddressDO.City ).getString();
     *         }
     *
     *    Using Query/DO classes:
     *      Pro: code is (often) clearer
     *      Con: code runs slower because you create more objects
     *
     *         PersonQuery pq = new PersonQuery();
     *         pq.setQueryFirstName( "Bob" );
     *         PersonDO[] bobs = pq.getDOArray();
     *         for ( int i = 0; i < bobs.length; i++ ) {
     *             AddressQuery aq = new AddressQuery();
     *             aq.setQueryPerson( bobs[i] );
     *             AddressDO addr = aq.getNextDO();
     *             String city = addr.getCity();
     *         }
     */
    static public final RDBTable  table = new RDBTable( "GENERICENUMVALUEDEFINITION" );

    /**
     * Return GENERICENUMVALUEDEFINITION as the name of the table in the database
     * which contains EnumValueDefinitionDO objects.
     * This method overrides CoreDO.getTableName()
     * and is used by CoreDO.executeUpdate() during error handling.
     *
     * @return the database table name
     * @see CoreDO
     * @author Jay Gunter
     */
// WebDocWf enhancement for public tablename
// The following line has been changed
    public String getTableName() {
// before: protected String getTableName() {
	return "GENERICENUMVALUEDEFINITION";
    }

   /**
    * static final RDBColumn PrimaryKey for use with QueryBuilder.
    * See example above.
    */
    static public final RDBColumn PrimaryKey = new RDBColumn( table,
					      getPrimaryKeyName() );
    /* RDBColumns for EnumValueDefinitionDO attributes are defined below. */

    /* Using a DO (and its Query class) to access a VIEW instead of a TABLE:
     *
     * A DO (and its Query class) can be used to access a VIEW
     * instead of a TABLE.  The Data Object is created as usual in DODS,
     * but the "create table" SQL command for that DO is not used.
     * Instead, you substitute a "create view" command to create a
     * virtual table in the database; this is often done to provide
     * convenient access to a collection of tables joined together.
     *
     * A VIEW usually does not return "oid" and "version" columns;
     * often (but now always) a VIEW is defined to return the "oid" column
     * for one of the tables joined together in the definition of the VIEW.
     * If the isView flag is true, EnumValueDefinitionDO.createExisting(ResultSet)
     * will NOT invoke the GenericDO(ResultSet) constructor
     * so to avoid attempting to extract the "oid" and "version" columns
     * from the ResultSet.
     */
    static protected final boolean isView = false;

    /**
     * A DO class contains a reference to a DataStruct class.
     * This reference can be null (when the data for the DO
     * has not yet been retrieved from the database),
     * allowing a DO object to be a lightweight placeholder
     * until its data is needed.
     */
    private EnumValueDefinitionDataStruct data = null;

    /**
     * isReadOnly()
     * Returns true if the data for this object has been marked read-only.
     */
    public boolean isReadOnly() {
	if ( null == data ) return false;
	return data.readOnly;
    }

    /**
     * Protected constructor.  Only derived classes should call it.
     *
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     */
    protected EnumValueDefinitionDO ( boolean is_view )
    throws ObjectIdException, DatabaseManagerException {
        super( is_view );
    }

    /**
     * Protected constructor.  Only derived classes should call it.
     *
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     */
    protected EnumValueDefinitionDO ()
    throws ObjectIdException, DatabaseManagerException {
        super( isView );
    }

    /**
     * isLoaded()
     * Returns true if the data for this objects has been retrieved
     * from the database.
     */
    public boolean isLoaded() {
	return ( null != data );
    }

    /**
     * loadData()
     * Load the fields for the DO from the database.
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    public void loadData()
    throws SQLException, ObjectIdException, DataObjectException
    {
	if ( null == data ) {
	    
	    data = new EnumValueDefinitionDataStruct ();
	}

	ObjectId id = getOId();
	if ( null == id )
	    return;
	if ( ! isPersistent() )   // DO from createVirgin
	    return;

	// DO from createExisting.  Complain if no record in database.
	EnumValueDefinitionQuery query = new EnumValueDefinitionQuery ();
	query.setQueryOId( id );
	query.requireUniqueInstance();
	EnumValueDefinitionDO obj;
	try {
	    obj = query.getNextDO();
	    if ( null == obj )
		throw new DataObjectException(
		    "EnumValueDefinitionDO DO not found for id=" + id );
	    makeIdentical(obj);
	    setVersion(    obj.getVersion() );
	    setNewVersion( obj.getVersion() );

	} catch ( NonUniqueQueryException e ) {
	    throw new ObjectIdException( "Duplicate ObjectId" );
	}
// WebDocWf fix for thread safe lazy loading
// The following lines have been added:

	obj = addToCache( obj );

// end of WebDocWf fix for thread safe lazy loading

    }
    /**
     * Load the actual DO data if necessary.
     * Called by get/set methods.
     *
     * @exception DataObjectException If a data access error occurs.
     */
    protected void checkLoad()
    throws DataObjectException {
	if ( null == data )
	    try {
		loadData();
	    } catch ( Exception e ) {
		throw new DataObjectException(
		    "Unable to load data for EnumValueDefinitionDO id=" + getOId() +
		    ", error = " + e.getMessage() );
	    }
    }

    /**
     * Protected constructor used by createExisting(ObjectId) above.
     *
     * @param id The ObjectId for the object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   Should never see this exception since GenericDO.ctor(ObjectId)
     *   never accesses the database.
     */
    protected EnumValueDefinitionDO( ObjectId id )
    throws SQLException, ObjectIdException, DataObjectException, DatabaseManagerException
    {
	super( id );
    }





    /**
     * A DO class that contains unchanging (static) data from the database
     * will have a cache of DOs representing the entire contents of the table.
     */
    static {
       try {
	    refreshCache();
       } catch ( Exception e ) {
	    // cannot throw from static block
       }
    }

    /**
     * The cache is used automatically by the class.
     * Callers of the create() methods do not know whether
     * the returned DO instance is shared or not.
     * This prevents the existence of multiple instances in memory
     * of the same database object.
     * The cache is instantiated when the first DO instance is created.
     * After the cache is instantiated, the Query class for this DO
     * will search only the cache.
     */
    private static Hashtable cache;

    private static Hashtable oldCache = null;

    /**
     * Queries all rows in table, and for each row
     * creates a DO instance in the cache.
     * For these DOs, data.readOnly = true,
     * which causes set methods to throw an exception.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    public static void refreshCache()
    throws java.sql.SQLException, DatabaseManagerException, ObjectIdException,
	   DataObjectException {
	    oldCache = cache;
	    cache = new Hashtable();

	    EnumValueDefinitionQuery query = new EnumValueDefinitionQuery ();
	    query.hitDatabase();
	    EnumValueDefinitionDO obj;
	    try {
		while ( null != ( obj = query.getNextDO() ) ) {
		    addToCache( obj );
		    obj.data.readOnly = true;
		}
	    } catch ( NonUniqueQueryException e ) {
		// Since we do not call query.requireUniqueInstance()
		// this should never happen.
		throw new ObjectIdException( "Duplicate ObjectId" );
	    } finally {
	     oldCache = null;
	    }

    }

    /**
     * Add DO to cache.
     * If DO already exists in cache, just the data member is replaced,
     * so that application references to the DO remain valid.
     */
    public static synchronized EnumValueDefinitionDO addToCache( EnumValueDefinitionDO newDO ) {
	String handle;
        try {
            handle = newDO.getHandle();
        } catch ( DatabaseManagerException e ) {
            return null;
        }
	EnumValueDefinitionDO oldDO = null;
	if ( null != oldCache ) {
	    oldDO = ( EnumValueDefinitionDO ) oldCache.get( handle );
	} else {
	    oldDO = ( EnumValueDefinitionDO ) cache.get( handle );
	}
	if ( null != oldDO ) {
	    oldDO.data = newDO.data;
	    newDO = oldDO;
	}
	cache.put( handle, newDO );
	return newDO;
    }

    /**
     * Retrieve contents of cache as an enumeration of DO objects.
     */
    public static Enumeration getCacheContents() {
	Enumeration ret = null;
	Hashtable h = null;
	h = cache;
	if ( null != h )
	    ret = h.elements();
        return ret;
    }



    /**
     * createVirgin()
     * Creates a DO that has no ObjectId or data.
     * Such a DO is used to insert a new database entry
     * after its data has been set.
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     */
    public static EnumValueDefinitionDO createVirgin()
    throws DatabaseManagerException, ObjectIdException {
	return new EnumValueDefinitionDO ();
    }
// WebDocWf extension for DODS row instance security
// The following lines have been added:
    /**
     * createVirgin()
     * Creates a DO that has no ObjectId or data.
     * Such a DO is used to insert a new database entry
     * after its data has been set.
     *
     * @param usr The user for security check
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception AccessException
     *   The user is not allowed to create new instances
     *
     * WebDocWf extension
     *
     */
    public static EnumValueDefinitionDO createVirgin( org.webdocwf.dods.access.User usr )
    throws DatabaseManagerException, ObjectIdException, AccessException {
        assertDOCreateAccess( usr );
	return createVirgin();
    }
    /**
     * Ensure that the given user is allowed to create new instances
     *
     * @param usr The user for security check
     *
     * @exception AccessException
     *   The user is not allowed to create new instances
     *
     * WebDocWf extension
     *
     */
    public static void assertDOCreateAccess( org.webdocwf.dods.access.User usr )
    throws AccessException {
	if (! hasDOCreateAccess( usr )) throw new AccessRightException("No access !", usr, "Get", null, "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO", null, null, null, null, null);
    }
    /**
     * Check whether the given user is allowed to create new instances
     *
     * @param usr The user for security check
     * @return Whether the given user is allowed to create new instances
     *
     * WebDocWf extension
     *
     */
    public static boolean hasDOCreateAccess( org.webdocwf.dods.access.User usr )
    throws AccessEvalException
    {
      	return usr.hasDOCreateAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO" );
    }
// end of WebDocWf extension for DODS row instance security

// WebDocWf extension for generic store
// The following lines have been addded
    /**
     * Create an instance for an existing row
     * This is a strange hack for having an instance method
     * Maybe there is a better solution ?
     *
     * WebDocWf extension
     *
     */
    public GenericStoreDO createForExisting( BigDecimal bd )
    throws SQLException, ObjectIdException, DataObjectException, DatabaseManagerException
    {
	return createExisting( bd );
    }
// end of WebDocWf extension for generic store

    /**
     * createExisting( BigDecimal )
     *
     * Factory method creates a EnumValueDefinitionDO object by searching for it
     * in the database using the passed BigDecimal value as the primary key.
     *
     * Creates a DO that represents an existing entry in the database.
     * Such a DO is used to examine and possibly update such an entry.
     * createExisting() is called only from the code that retrieves
     * an ObjectId from a ResultSet (database query result).
     * createExisting() is protected because no other DO or BO should ever
     * need to call it.
     * FIX unfortunately the createExisting(BigDecimal) form *does* need
     * to be public because it is called by the public ctors of other DOs.
     * For example,
     *    AaaDO contains a ref to a BbbDO,
     *    so there is a method AaaDO.setBbb(BbbDO).
     *    In the ctor AaaDO(ResultSet), we have the call
     *       setBbb( BbbDO.createExisting( rs.getBigDecimal( "bbb", 0 )));
     * Since AaaDO is not in the same package as BbbDO,
     * BbbDO.createExisting(BigDecimal) must be public, not protected.
     * Java needs the C++ 'friend' idea.
     *
     * @param bd The BigDecimal representation of the ObjectId for the object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    public static EnumValueDefinitionDO createExisting( BigDecimal bd )
    throws SQLException, ObjectIdException, DataObjectException, DatabaseManagerException
    {
	if ( null == bd )
	    return null;
	return createExisting( new ObjectId( bd ) );
    }
// WebDocWf extension for DODS row instance security
// The following lines have been added:
    /**
     * createExisting( BigDecimal )
     *
     * Factory method creates a EnumValueDefinitionDO object by searching for it
     * in the database using the passed BigDecimal value as the primary key.
     *
     * @param bd The BigDecimal representation of the ObjectId for the object.
     * @param usr The user for security check
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     * @exception AccessException
     *   The user is not allowed to read the instance existance
     *   
     * WebDocWf extension
     *   
     */
    public static EnumValueDefinitionDO createExisting( BigDecimal bd, org.webdocwf.dods.access.User usr )
    throws SQLException, ObjectIdException, DataObjectException, DatabaseManagerException, AccessException
    {
	if ( null == bd )
	    return null;
	EnumValueDefinitionDO ret = createExisting( new ObjectId( bd ) );
	ret.assertDOGetAccess( usr );
	return ret;
    }
    /**
     * Check whether the given user is allowed to read the DO existance
     * Static function to be called without having the object
     *
     * @param bd The BigDecimal representation of the ObjectId for the object.
     * @param usr The user for security check
     * @return Whether the given user is allowed to read the DO existance
     *   
     * WebDocWf extension
     *   
     */
    public static boolean hasDOGetAccess( BigDecimal bd, org.webdocwf.dods.access.User usr ) 
    throws AccessEvalException
    {
	EnumValueDefinitionDO newDO;
	try {
	  newDO = createExisting( new ObjectId( bd ) );
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDoGetAccess/createExisting !", e, usr, "Get", null, "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO", null, null, null, null, null);
	}
	return usr.hasDOGetAccess( newDO );
    }
// end of WebDocWf extension for DODS row instance security

    /**
     * The createExisting method is used to create a <CODE>EnumValueDefinitionDO</CODE>
     * from a string handle.
     */
    public static EnumValueDefinitionDO createExisting( String handle ) {
	EnumValueDefinitionDO ret = null;
        try {
            BigDecimal bd = new BigDecimal( handle );
	    ret = createExisting( bd );
        } catch ( Exception e ) {
        }
	return ret;
    }
// WebDocWf extension for DODS row instance security
// The following lines have been added:
    /**
     * The createExisting method is used to create a <CODE>EnumValueDefinitionDO</CODE>
     * from a string handle.
     *   
     * WebDocWf extension
     *   
     */
    public static EnumValueDefinitionDO createExisting( String handle, org.webdocwf.dods.access.User usr )
    throws AccessException
    {
	EnumValueDefinitionDO ret = createExisting( handle );
        if (ret!=null)
        {
          ret.assertDOGetAccess( usr );
        }
	return ret;
    }
    /**
     * Check whether the given user is allowed to read the DO existance
     * Static function to be called without having the object
     *
     * @param handle The string representation of the ObjectId for the object.
     * @param usr The user for security check
     * @return Whether the given user is allowed to read the DO existance
     *   
     * WebDocWf extension
     *   
     */
    public static boolean hasDOGetAccess( String handle, org.webdocwf.dods.access.User usr ) throws AccessEvalException {
	EnumValueDefinitionDO newDO;
	try {
	  newDO = createExisting( handle );
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDoGetAccess/createExisting !", e, usr, "Get", null, "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO", null, null, null, null, null);
	}
	return usr.hasDOGetAccess( newDO );
    }
// end of WebDocWf extension for DODS row instance security

    /**
     * createExisting( ObjectId )
     *
     * Factory method creates a EnumValueDefinitionDO object by searching for it
     * in the database using the passed ObjectID value as the primary key.
     *
     * @param id The ObjectId for the object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    protected static EnumValueDefinitionDO createExisting( ObjectId id )
    throws SQLException, ObjectIdException, DataObjectException, DatabaseManagerException
    {
	if ( null == id )
	    return null;
	EnumValueDefinitionDO ret = null;

	String handle = id.toString();
	ret = findCachedObjectByHandle( handle );
	if ( null != ret )
	    return ret;

	ret = new EnumValueDefinitionDO( id );
	ret.setPersistent( true );  // mark DO as persistent (preexisting)
	if ( ! false ) // If not lazy-loading, fetch DO data now.
	    ret.loadData();
// WebDocWf fix for thread safe lazyloading
// The following lines have been put under comments:
//
//	ret = addToCache( ret );
//
// end of WebDocWf fix for thread safe lazyloading
	// unset the GenericDO.dirty flag.
	ret.markClean();
	return ret;
    }

    /**
     * createExisting( ResultSet )
     *
     * Factory method used to create an instance of this class to
     * represent a Data Object already existing in the database.
     *
     * @param rs The ResultSet returned by the Query class for
     * an existing Data Object stored in the database.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    protected static EnumValueDefinitionDO createExisting( ResultSet rs )
    throws SQLException, ObjectIdException, DataObjectException
		, DatabaseManagerException
    {
	if ( null == rs )
	    return null;
	EnumValueDefinitionDO ret = null;
	if ( isView ) {
	    ret = new EnumValueDefinitionDO ();
	    ret.initFromResultSet( rs );
	} else {
	    ret = new EnumValueDefinitionDO ( rs );
	}
// WebDocWf fix for thread safe lazyloading
// The following lines have been put under comments:
//
//	ret = addToCache( ret );
//
// end of WebDocWf fix for thread safe lazyloading
	return ret;
    }

    /**
     * createExisting( RDBRow )
     *
     * Factory method creates a EnumValueDefinitionDO object by searching for it
     * in the database using the EnumValueDefinitionDO.PrimaryKey value
     * in the passed RDBRow.
     *
     * @param RDBRow A row returned by QueryBuilder.getNextRow().
     *
     * @exception DataObjectException
     *   If the RDBRow does not contain a EnumValueDefinitionDO.PrimaryKey.
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    protected static EnumValueDefinitionDO createExisting( RDBRow row )
    throws SQLException, ObjectIdException, DataObjectException
		, DatabaseManagerException
    {
	if ( null == row )
	    return null;
        RDBColumnValue pk = null;
        try {
	    pk = row.get( EnumValueDefinitionDO.PrimaryKey );
	    return createExisting( pk );
        } catch ( Exception e ) {
	    throw new DataObjectException(
		"Cannot create EnumValueDefinitionDO, row does not " +
		"contain EnumValueDefinitionDO primary key." );
        }
    }

    /**
     * createExisting( RDBColumnValue )
     *
     * Factory method creates a EnumValueDefinitionDO object by searching for it
     * in the database using the passed EnumValueDefinitionDO.PrimaryKey.
     *
     * @param RDBColumnValue a PrimaryKey column value from a row
     * that was returned by QueryBuilder.getNextRow().
     *
     * @exception DataObjectException
     *   If the RDBColumnValue does not contain a EnumValueDefinitionDO.PrimaryKey.
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    protected static EnumValueDefinitionDO createExisting( RDBColumnValue pk )
    throws SQLException, ObjectIdException, DataObjectException
		, DatabaseManagerException
    {
	if ( null == pk )
	    return null;
	if ( ! pk.equals( EnumValueDefinitionDO.PrimaryKey ) )
	    throw new DataObjectException(
		"Cannot create EnumValueDefinitionDO, " +
		"RDBColumnValue is not EnumValueDefinitionDO.PrimaryKey." );
	BigDecimal bd = null;
        try {
	    bd = pk.getBigDecimal();
        } catch ( Exception e ) {
	    throw new DataObjectException(
		"Cannot create EnumValueDefinitionDO, bad primary key." );
        }
	if ( null == bd )
            return null;
	return createExisting( bd );
    }

    /**
     * createCopy()
     * Creates a DO that has no ObjectId
     * but has a copy of an existing DO's data.
     * Such a DO is used to insert a new database entry
     * that is largely similar to an existing entry.
     *
     * @param data The data struct to copy values from.
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     */
    public static EnumValueDefinitionDO createCopy( EnumValueDefinitionDataStruct data )
    throws DatabaseManagerException, ObjectIdException {
	EnumValueDefinitionDO ret = new EnumValueDefinitionDO ();
	ret.data = ( EnumValueDefinitionDataStruct ) data.duplicate();
	return ret;
    }

    /**
     * createCopy()
     * Creates a DO that has no ObjectId
     * but has a copy of an existing DO's data.
     * Such a DO is used to insert a new database entry
     * that is largely similar to an existing entry.
     *
     * @param orig The original DO to copy.
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     */
    public static EnumValueDefinitionDO createCopy( EnumValueDefinitionDO orig )
    throws DatabaseManagerException, ObjectIdException {
	EnumValueDefinitionDO ret = new EnumValueDefinitionDO ();
	if ( null != orig.data ) {
	    ret.data = ( EnumValueDefinitionDataStruct ) orig.data.duplicate();
	}
	return ret;
    }
// WebDocWf extension for DODS row instance security
// The following lines have been added:
    /**
     * createCopy()
     * Creates a DO that has no ObjectId
     * but has a copy of an existing DO's data.
     * Such a DO is used to insert a new database entry
     * that is largely similar to an existing entry.
     *
     * @param orig The original DO to copy.
     * @param usr The user for security check
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception AccessException
     *   The user is not allowed to make a copy
     *
     * WebDocWf extension
     *
     */
    public static EnumValueDefinitionDO createCopy( EnumValueDefinitionDO orig, org.webdocwf.dods.access.User usr )
    throws DatabaseManagerException, ObjectIdException, AccessException {
        orig.assertDOCopyAccess ( usr );
	EnumValueDefinitionDO ret = createCopy ( orig );
	return ret;
    }
// end of WebDocWf extension for DODS row instance security

    /**
     * reload()
     * Causes the DO to refresh itself from the database
     * the next time a set or get method is called.
     */
    public void reload() {
	data = null;
    }


    /**
     * The methods <CODE>
     *     getHandle
     *     hasMatchingHandle

     *     findCachedObjectByHandle

     * </CODE> are used by Presentation Objects that need to populate
     * HTML select lists with Data Objects as options.
     * The <CODE>getHandle()</CODE> method is used
     * to set the value for each option,
     * and the <CODE>hasMatchingHandle()<CODE>

     * and <CODE>findCachedObjectByHandle()<CODE>

     * methods are used to lookup the Data Object when the selection has
     * been made.
     *
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     *
     * @return id of this DO as a string
     *   If an object id can't be allocated for this object.
     */
    public        String  getHandle()
    throws DatabaseManagerException {
	String ret = null;
	    if ( null == getOId() )
		   throw new DatabaseManagerException( "ID not set" );
	    ret = getOId().toString();
        return ret;
    }

   /**
     * hasMatchingHandle
     *
     * @param handle
     *   <CODE>String</CODE> version of DO id
     * @return boolean
     *   True if the string version of the id of this DO matches passed handle
     */
    public        boolean hasMatchingHandle( String handle ) {
	boolean ret = false;
	    if ( null == getOId() )
		   ret = false;
	    else
		   ret = getOId().toString().equals( handle );
        return ret;
    }


   /**
     * findCachedObjectByHandle
     *
     * @param handle
     *   <CODE>String</CODE> version of DO id
     * @return <CODE>EnumValueDefinitionDO</CODE>
     *   Object if one is found in cache, otherwise null.
     */
    public static EnumValueDefinitionDO findCachedObjectByHandle( String handle ){
        if ( null == handle )
            return null;
        if ( null == cache )
            return null;
        return ( EnumValueDefinitionDO ) cache.get( handle );
    }
// WebDocWf extension for DODS row instance security
// The following lines have been added:
   /**
     * findCachedObjectByHandle
     *
     * @param handle
     *   <CODE>String</CODE> version of DO id
     * @param usr The user for security check
     * @return <CODE>EnumValueDefinitionDO</CODE>
     *   Object if one is found in cache, otherwise null.
     * @exception AccessException
     *   The user is not allowed to read the object existance
     *
     * WebDocWf extension
     *
     */
    public static EnumValueDefinitionDO findCachedObjectByHandle( String handle, org.webdocwf.dods.access.User usr )
	throws AccessException {
        EnumValueDefinitionDO ret = findCachedObjectByHandle( handle );
	if (ret != null) ret.assertDOGetAccess( usr );
	return ret;
    }
// end of WebDocWf extension for DODS row instance security



    /**
     * makeIdentical()
     *
     * Assigns the DataStruct of an existing DO to this DO.
     * Does not duplicate data. Just assigns the reference.
     *
     * @param orig The original DO.
     *
     */
    protected void makeIdentical( EnumValueDefinitionDO orig ) {
	super.makeIdentical(orig);
	data = orig.data;
    }
// WebDocWf extension for writeable fully cached obejcts
    /**
     * makeReadOnly()
     * Mark the object as readonly
     * 
     * WebDocWf extension
     * 
     */
    public void makeReadOnly() {
	if ( null != data ) data.readOnly=true;
    }
    /**
     * Mark the object as readwrite
     * 
     * WebDocWf extension
     * 
     */
    /**
     * makeReadWrite()
     */
    public void makeReadWrite() {
	if ( null != data ) data.readOnly=false;
    }
// end of WebDocWf extension for writeable fully cached obejcts

////////////////////////// data member ENUMTYPEDEFINITIONOID

   
   /* static final RDBColumn ENUMTYPEDEFINITIONOID for use with QueryBuilder.
    * See RDBColumn PrimaryKey at the top of this file for usage example.
    */
   static public final RDBColumn ENUMTYPEDEFINITIONOID = 
		new RDBColumn( table, "ENUMTYPEDEFINITIONOID", true );

   
   

   /**
    * Get ENUMTYPEDEFINITIONOID of the GENERICENUMVALUEDEFINITION
    *
    * @return ENUMTYPEDEFINITIONOID of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO getENUMTYPEDEFINITIONOID () 
   throws DataObjectException {
   
      checkLoad();
   
      return data.ENUMTYPEDEFINITIONOID;
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Get ENUMTYPEDEFINITIONOID of the GENERICENUMVALUEDEFINITION
    *
    * @param usr The user for security check
    * @return ENUMTYPEDEFINITIONOID of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO getENUMTYPEDEFINITIONOID ( org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOGetAttrENUMTYPEDEFINITIONOIDAccess( usr );
      org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO ret = getENUMTYPEDEFINITIONOID();
      assertDOGetDOValueAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:ENUMTYPEDEFINITIONOID", ret, usr );
      return ret;
   }
   /**
    * Ensure that the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOGetAttrENUMTYPEDEFINITIONOIDAccess( org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOGetAttrENUMTYPEDEFINITIONOIDAccess( usr )) throw new AccessRightException( "No access", usr, "GetAttr", this, null, "ENUMTYPEDEFINITIONOID", null, null, "org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO", null);
   }

   /**
    * Check whether the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetAttrENUMTYPEDEFINITIONOIDAccess( org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	return hasDOGetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:ENUMTYPEDEFINITIONOID", data.ENUMTYPEDEFINITIONOID, usr );
   }
   /**
    * Check whether the given user is allowed to read object in a pointer attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetDOValueENUMTYPEDEFINITIONOIDAccess ( org.webdocwf.dods.access.User usr ) 
   throws AccessEvalException {
	org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO val;
	try {
        val = getENUMTYPEDEFINITIONOID();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOGetDOValueENUMTYPEDEFINITIONOIDAccess/getENUMTYPEDEFINITIONOID !", e, usr, "GetAttr", this, null, "ENUMTYPEDEFINITIONOID", null, null, "org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO", null);
	}
      return hasDOGetDOValueAccess(val, usr);
   }
// end of WebDocWf extension for DODS row instance security

   
   /**
    * Set ENUMTYPEDEFINITIONOID of the GENERICENUMVALUEDEFINITION
    *
    * @param ENUMTYPEDEFINITIONOID of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setENUMTYPEDEFINITIONOID ( org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO ENUMTYPEDEFINITIONOID )
   throws DataObjectException {
      checkLoad();
      data.ENUMTYPEDEFINITIONOID = (org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO) markNewValue(
	data.ENUMTYPEDEFINITIONOID, ENUMTYPEDEFINITIONOID  );
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Set ENUMTYPEDEFINITIONOID of the GENERICENUMVALUEDEFINITION
    *
    * @param ENUMTYPEDEFINITIONOID of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void setENUMTYPEDEFINITIONOID ( org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO ENUMTYPEDEFINITIONOID, org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOSetAttrENUMTYPEDEFINITIONOIDAccess( ENUMTYPEDEFINITIONOID, usr );
      setENUMTYPEDEFINITIONOID( ENUMTYPEDEFINITIONOID );
   }
   /**
    * Ensure that the given user is allowed to update the attribute
    *
    * @param ENUMTYPEDEFINITIONOID of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOSetAttrENUMTYPEDEFINITIONOIDAccess( org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO ENUMTYPEDEFINITIONOID, org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOSetAttrENUMTYPEDEFINITIONOIDAccess( ENUMTYPEDEFINITIONOID, usr )) throw new AccessRightException( "No access", usr, "SetAttr", this, null, "ENUMTYPEDEFINITIONOID", null, null, "org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO", null);
   }
   /**
    * Check whether the given user is allowed to update the attribute
    *
    * @param ENUMTYPEDEFINITIONOID of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    * @return Whether the given user is allowed to update the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOSetAttrENUMTYPEDEFINITIONOIDAccess( org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO ENUMTYPEDEFINITIONOID, org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	try {
	checkLoad();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOSetAttrENUMTYPEDEFINITIONOIDAccess/checkLoad !", e, usr, "SetAttr", this, null, "ENUMTYPEDEFINITIONOID", null, null, "org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO", null);
	}
	return hasDOSetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:ENUMTYPEDEFINITIONOID", data.ENUMTYPEDEFINITIONOID,ENUMTYPEDEFINITIONOID,usr );
   }
// end of WebDocWf extension for DODS row instance security
   


////////////////////////// data member BEGINSTATE

   
   /* static final RDBColumn BEGINSTATE for use with QueryBuilder.
    * See RDBColumn PrimaryKey at the top of this file for usage example.
    */
   static public final RDBColumn BEGINSTATE = 
		new RDBColumn( table, "BEGINSTATE", false );

   
   

   /**
    * Get BEGINSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @return BEGINSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public boolean getBEGINSTATE () 
   throws DataObjectException {
   
      checkLoad();
   
      return data.BEGINSTATE;
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Get BEGINSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @param usr The user for security check
    * @return BEGINSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public boolean getBEGINSTATE ( org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOGetAttrBEGINSTATEAccess( usr );
      boolean ret = getBEGINSTATE();
      assertDOGetDOValueAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:BEGINSTATE", ret, usr );
      return ret;
   }
   /**
    * Ensure that the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOGetAttrBEGINSTATEAccess( org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOGetAttrBEGINSTATEAccess( usr )) throw new AccessRightException( "No access", usr, "GetAttr", this, null, "BEGINSTATE", null, null, "boolean", null);
   }

   /**
    * Check whether the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetAttrBEGINSTATEAccess( org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	return hasDOGetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:BEGINSTATE", data.BEGINSTATE, usr );
   }
   /**
    * Check whether the given user is allowed to read object in a pointer attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetDOValueBEGINSTATEAccess ( org.webdocwf.dods.access.User usr ) 
   throws AccessEvalException {
	boolean val;
	try {
        val = getBEGINSTATE();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOGetDOValueBEGINSTATEAccess/getBEGINSTATE !", e, usr, "GetAttr", this, null, "BEGINSTATE", null, null, "boolean", null);
	}
      return hasDOGetDOValueAccess(val, usr);
   }
// end of WebDocWf extension for DODS row instance security

   
   /**
    * Set BEGINSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @param BEGINSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setBEGINSTATE ( boolean BEGINSTATE )
   throws DataObjectException {
      checkLoad();
      data.BEGINSTATE =  markNewValue(
	data.BEGINSTATE, BEGINSTATE  );
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Set BEGINSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @param BEGINSTATE of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void setBEGINSTATE ( boolean BEGINSTATE, org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOSetAttrBEGINSTATEAccess( BEGINSTATE, usr );
      setBEGINSTATE( BEGINSTATE );
   }
   /**
    * Ensure that the given user is allowed to update the attribute
    *
    * @param BEGINSTATE of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOSetAttrBEGINSTATEAccess( boolean BEGINSTATE, org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOSetAttrBEGINSTATEAccess( BEGINSTATE, usr )) throw new AccessRightException( "No access", usr, "SetAttr", this, null, "BEGINSTATE", null, null, "boolean", null);
   }
   /**
    * Check whether the given user is allowed to update the attribute
    *
    * @param BEGINSTATE of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    * @return Whether the given user is allowed to update the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOSetAttrBEGINSTATEAccess( boolean BEGINSTATE, org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	try {
	checkLoad();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOSetAttrBEGINSTATEAccess/checkLoad !", e, usr, "SetAttr", this, null, "BEGINSTATE", null, null, "boolean", null);
	}
	return hasDOSetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:BEGINSTATE", data.BEGINSTATE,BEGINSTATE,usr );
   }
// end of WebDocWf extension for DODS row instance security
   


////////////////////////// data member ENDSTATE

   
   /* static final RDBColumn ENDSTATE for use with QueryBuilder.
    * See RDBColumn PrimaryKey at the top of this file for usage example.
    */
   static public final RDBColumn ENDSTATE = 
		new RDBColumn( table, "ENDSTATE", false );

   
   

   /**
    * Get ENDSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @return ENDSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public boolean getENDSTATE () 
   throws DataObjectException {
   
      checkLoad();
   
      return data.ENDSTATE;
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Get ENDSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @param usr The user for security check
    * @return ENDSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public boolean getENDSTATE ( org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOGetAttrENDSTATEAccess( usr );
      boolean ret = getENDSTATE();
      assertDOGetDOValueAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:ENDSTATE", ret, usr );
      return ret;
   }
   /**
    * Ensure that the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOGetAttrENDSTATEAccess( org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOGetAttrENDSTATEAccess( usr )) throw new AccessRightException( "No access", usr, "GetAttr", this, null, "ENDSTATE", null, null, "boolean", null);
   }

   /**
    * Check whether the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetAttrENDSTATEAccess( org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	return hasDOGetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:ENDSTATE", data.ENDSTATE, usr );
   }
   /**
    * Check whether the given user is allowed to read object in a pointer attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetDOValueENDSTATEAccess ( org.webdocwf.dods.access.User usr ) 
   throws AccessEvalException {
	boolean val;
	try {
        val = getENDSTATE();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOGetDOValueENDSTATEAccess/getENDSTATE !", e, usr, "GetAttr", this, null, "ENDSTATE", null, null, "boolean", null);
	}
      return hasDOGetDOValueAccess(val, usr);
   }
// end of WebDocWf extension for DODS row instance security

   
   /**
    * Set ENDSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @param ENDSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setENDSTATE ( boolean ENDSTATE )
   throws DataObjectException {
      checkLoad();
      data.ENDSTATE =  markNewValue(
	data.ENDSTATE, ENDSTATE  );
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Set ENDSTATE of the GENERICENUMVALUEDEFINITION
    *
    * @param ENDSTATE of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void setENDSTATE ( boolean ENDSTATE, org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOSetAttrENDSTATEAccess( ENDSTATE, usr );
      setENDSTATE( ENDSTATE );
   }
   /**
    * Ensure that the given user is allowed to update the attribute
    *
    * @param ENDSTATE of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOSetAttrENDSTATEAccess( boolean ENDSTATE, org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOSetAttrENDSTATEAccess( ENDSTATE, usr )) throw new AccessRightException( "No access", usr, "SetAttr", this, null, "ENDSTATE", null, null, "boolean", null);
   }
   /**
    * Check whether the given user is allowed to update the attribute
    *
    * @param ENDSTATE of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    * @return Whether the given user is allowed to update the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOSetAttrENDSTATEAccess( boolean ENDSTATE, org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	try {
	checkLoad();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOSetAttrENDSTATEAccess/checkLoad !", e, usr, "SetAttr", this, null, "ENDSTATE", null, null, "boolean", null);
	}
	return hasDOSetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:ENDSTATE", data.ENDSTATE,ENDSTATE,usr );
   }
// end of WebDocWf extension for DODS row instance security
   


////////////////////////// data member LONGNAME

   
   /* static final RDBColumn LONGNAME for use with QueryBuilder.
    * See RDBColumn PrimaryKey at the top of this file for usage example.
    */
   static public final RDBColumn LONGNAME = 
		new RDBColumn( table, "LONGNAME", true );

   static public final int LONGNAME_MaxLength = 100;
   

   /**
    * Get LONGNAME of the GENERICENUMVALUEDEFINITION
    *
    * @return LONGNAME of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public String getLONGNAME () 
   throws DataObjectException {
   
      checkLoad();
   
      return data.LONGNAME;
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Get LONGNAME of the GENERICENUMVALUEDEFINITION
    *
    * @param usr The user for security check
    * @return LONGNAME of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public String getLONGNAME ( org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOGetAttrLONGNAMEAccess( usr );
      String ret = getLONGNAME();
      assertDOGetDOValueAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:LONGNAME", ret, usr );
      return ret;
   }
   /**
    * Ensure that the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOGetAttrLONGNAMEAccess( org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOGetAttrLONGNAMEAccess( usr )) throw new AccessRightException( "No access", usr, "GetAttr", this, null, "LONGNAME", null, null, "String", null);
   }

   /**
    * Check whether the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetAttrLONGNAMEAccess( org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	return hasDOGetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:LONGNAME", data.LONGNAME, usr );
   }
   /**
    * Check whether the given user is allowed to read object in a pointer attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetDOValueLONGNAMEAccess ( org.webdocwf.dods.access.User usr ) 
   throws AccessEvalException {
	String val;
	try {
        val = getLONGNAME();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOGetDOValueLONGNAMEAccess/getLONGNAME !", e, usr, "GetAttr", this, null, "LONGNAME", null, null, "String", null);
	}
      return hasDOGetDOValueAccess(val, usr);
   }
// end of WebDocWf extension for DODS row instance security

   
   /**
    * Set LONGNAME of the GENERICENUMVALUEDEFINITION
    *
    * @param LONGNAME of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setLONGNAME ( String LONGNAME )
   throws DataObjectException {
      checkLoad();
      data.LONGNAME =  markNewValue(
	data.LONGNAME, LONGNAME , 0, LONGNAME_MaxLength, false );
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Set LONGNAME of the GENERICENUMVALUEDEFINITION
    *
    * @param LONGNAME of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void setLONGNAME ( String LONGNAME, org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOSetAttrLONGNAMEAccess( LONGNAME, usr );
      setLONGNAME( LONGNAME );
   }
   /**
    * Ensure that the given user is allowed to update the attribute
    *
    * @param LONGNAME of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOSetAttrLONGNAMEAccess( String LONGNAME, org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOSetAttrLONGNAMEAccess( LONGNAME, usr )) throw new AccessRightException( "No access", usr, "SetAttr", this, null, "LONGNAME", null, null, "String", null);
   }
   /**
    * Check whether the given user is allowed to update the attribute
    *
    * @param LONGNAME of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    * @return Whether the given user is allowed to update the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOSetAttrLONGNAMEAccess( String LONGNAME, org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	try {
	checkLoad();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOSetAttrLONGNAMEAccess/checkLoad !", e, usr, "SetAttr", this, null, "LONGNAME", null, null, "String", null);
	}
	return hasDOSetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:LONGNAME", data.LONGNAME,LONGNAME,usr );
   }
// end of WebDocWf extension for DODS row instance security
   


////////////////////////// data member SHORTNAME

   
   /* static final RDBColumn SHORTNAME for use with QueryBuilder.
    * See RDBColumn PrimaryKey at the top of this file for usage example.
    */
   static public final RDBColumn SHORTNAME = 
		new RDBColumn( table, "SHORTNAME", true );

   static public final int SHORTNAME_MaxLength = 12;
   

   /**
    * Get SHORTNAME of the GENERICENUMVALUEDEFINITION
    *
    * @return SHORTNAME of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public String getSHORTNAME () 
   throws DataObjectException {
   
      checkLoad();
   
      return data.SHORTNAME;
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Get SHORTNAME of the GENERICENUMVALUEDEFINITION
    *
    * @param usr The user for security check
    * @return SHORTNAME of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public String getSHORTNAME ( org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOGetAttrSHORTNAMEAccess( usr );
      String ret = getSHORTNAME();
      assertDOGetDOValueAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:SHORTNAME", ret, usr );
      return ret;
   }
   /**
    * Ensure that the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOGetAttrSHORTNAMEAccess( org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOGetAttrSHORTNAMEAccess( usr )) throw new AccessRightException( "No access", usr, "GetAttr", this, null, "SHORTNAME", null, null, "String", null);
   }

   /**
    * Check whether the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetAttrSHORTNAMEAccess( org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	return hasDOGetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:SHORTNAME", data.SHORTNAME, usr );
   }
   /**
    * Check whether the given user is allowed to read object in a pointer attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetDOValueSHORTNAMEAccess ( org.webdocwf.dods.access.User usr ) 
   throws AccessEvalException {
	String val;
	try {
        val = getSHORTNAME();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOGetDOValueSHORTNAMEAccess/getSHORTNAME !", e, usr, "GetAttr", this, null, "SHORTNAME", null, null, "String", null);
	}
      return hasDOGetDOValueAccess(val, usr);
   }
// end of WebDocWf extension for DODS row instance security

   
   /**
    * Set SHORTNAME of the GENERICENUMVALUEDEFINITION
    *
    * @param SHORTNAME of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setSHORTNAME ( String SHORTNAME )
   throws DataObjectException {
      checkLoad();
      data.SHORTNAME =  markNewValue(
	data.SHORTNAME, SHORTNAME , 0, SHORTNAME_MaxLength, false );
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Set SHORTNAME of the GENERICENUMVALUEDEFINITION
    *
    * @param SHORTNAME of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void setSHORTNAME ( String SHORTNAME, org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOSetAttrSHORTNAMEAccess( SHORTNAME, usr );
      setSHORTNAME( SHORTNAME );
   }
   /**
    * Ensure that the given user is allowed to update the attribute
    *
    * @param SHORTNAME of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOSetAttrSHORTNAMEAccess( String SHORTNAME, org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOSetAttrSHORTNAMEAccess( SHORTNAME, usr )) throw new AccessRightException( "No access", usr, "SetAttr", this, null, "SHORTNAME", null, null, "String", null);
   }
   /**
    * Check whether the given user is allowed to update the attribute
    *
    * @param SHORTNAME of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    * @return Whether the given user is allowed to update the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOSetAttrSHORTNAMEAccess( String SHORTNAME, org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	try {
	checkLoad();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOSetAttrSHORTNAMEAccess/checkLoad !", e, usr, "SetAttr", this, null, "SHORTNAME", null, null, "String", null);
	}
	return hasDOSetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:SHORTNAME", data.SHORTNAME,SHORTNAME,usr );
   }
// end of WebDocWf extension for DODS row instance security
   


////////////////////////// data member KEYVALUE

   
   /* static final RDBColumn KEYVALUE for use with QueryBuilder.
    * See RDBColumn PrimaryKey at the top of this file for usage example.
    */
   static public final RDBColumn KEYVALUE = 
		new RDBColumn( table, "KEYVALUE", true );

   static public final int KEYVALUE_MaxLength = 254;
   

   /**
    * Get KEYVALUE of the GENERICENUMVALUEDEFINITION
    *
    * @return KEYVALUE of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public String getKEYVALUE () 
   throws DataObjectException {
   
      checkLoad();
   
      return data.KEYVALUE;
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Get KEYVALUE of the GENERICENUMVALUEDEFINITION
    *
    * @param usr The user for security check
    * @return KEYVALUE of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public String getKEYVALUE ( org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOGetAttrKEYVALUEAccess( usr );
      String ret = getKEYVALUE();
      assertDOGetDOValueAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:KEYVALUE", ret, usr );
      return ret;
   }
   /**
    * Ensure that the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOGetAttrKEYVALUEAccess( org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOGetAttrKEYVALUEAccess( usr )) throw new AccessRightException( "No access", usr, "GetAttr", this, null, "KEYVALUE", null, null, "String", null);
   }

   /**
    * Check whether the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetAttrKEYVALUEAccess( org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	return hasDOGetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:KEYVALUE", data.KEYVALUE, usr );
   }
   /**
    * Check whether the given user is allowed to read object in a pointer attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetDOValueKEYVALUEAccess ( org.webdocwf.dods.access.User usr ) 
   throws AccessEvalException {
	String val;
	try {
        val = getKEYVALUE();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOGetDOValueKEYVALUEAccess/getKEYVALUE !", e, usr, "GetAttr", this, null, "KEYVALUE", null, null, "String", null);
	}
      return hasDOGetDOValueAccess(val, usr);
   }
// end of WebDocWf extension for DODS row instance security

   
   /**
    * Set KEYVALUE of the GENERICENUMVALUEDEFINITION
    *
    * @param KEYVALUE of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setKEYVALUE ( String KEYVALUE )
   throws DataObjectException {
      checkLoad();
      data.KEYVALUE =  markNewValue(
	data.KEYVALUE, KEYVALUE , 0, KEYVALUE_MaxLength, false );
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Set KEYVALUE of the GENERICENUMVALUEDEFINITION
    *
    * @param KEYVALUE of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void setKEYVALUE ( String KEYVALUE, org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOSetAttrKEYVALUEAccess( KEYVALUE, usr );
      setKEYVALUE( KEYVALUE );
   }
   /**
    * Ensure that the given user is allowed to update the attribute
    *
    * @param KEYVALUE of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOSetAttrKEYVALUEAccess( String KEYVALUE, org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOSetAttrKEYVALUEAccess( KEYVALUE, usr )) throw new AccessRightException( "No access", usr, "SetAttr", this, null, "KEYVALUE", null, null, "String", null);
   }
   /**
    * Check whether the given user is allowed to update the attribute
    *
    * @param KEYVALUE of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    * @return Whether the given user is allowed to update the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOSetAttrKEYVALUEAccess( String KEYVALUE, org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	try {
	checkLoad();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOSetAttrKEYVALUEAccess/checkLoad !", e, usr, "SetAttr", this, null, "KEYVALUE", null, null, "String", null);
	}
	return hasDOSetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:KEYVALUE", data.KEYVALUE,KEYVALUE,usr );
   }
// end of WebDocWf extension for DODS row instance security
   


////////////////////////// data member XMLNAME

   
   /* static final RDBColumn XMLNAME for use with QueryBuilder.
    * See RDBColumn PrimaryKey at the top of this file for usage example.
    */
   static public final RDBColumn XMLNAME = 
		new RDBColumn( table, "XMLNAME", true );

   static public final int XMLNAME_MaxLength = 30;
   

   /**
    * Get XMLNAME of the GENERICENUMVALUEDEFINITION
    *
    * @return XMLNAME of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public String getXMLNAME () 
   throws DataObjectException {
   
      checkLoad();
   
      return data.XMLNAME;
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Get XMLNAME of the GENERICENUMVALUEDEFINITION
    *
    * @param usr The user for security check
    * @return XMLNAME of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public String getXMLNAME ( org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOGetAttrXMLNAMEAccess( usr );
      String ret = getXMLNAME();
      assertDOGetDOValueAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:XMLNAME", ret, usr );
      return ret;
   }
   /**
    * Ensure that the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOGetAttrXMLNAMEAccess( org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOGetAttrXMLNAMEAccess( usr )) throw new AccessRightException( "No access", usr, "GetAttr", this, null, "XMLNAME", null, null, "String", null);
   }

   /**
    * Check whether the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetAttrXMLNAMEAccess( org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	return hasDOGetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:XMLNAME", data.XMLNAME, usr );
   }
   /**
    * Check whether the given user is allowed to read object in a pointer attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetDOValueXMLNAMEAccess ( org.webdocwf.dods.access.User usr ) 
   throws AccessEvalException {
	String val;
	try {
        val = getXMLNAME();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOGetDOValueXMLNAMEAccess/getXMLNAME !", e, usr, "GetAttr", this, null, "XMLNAME", null, null, "String", null);
	}
      return hasDOGetDOValueAccess(val, usr);
   }
// end of WebDocWf extension for DODS row instance security

   
   /**
    * Set XMLNAME of the GENERICENUMVALUEDEFINITION
    *
    * @param XMLNAME of the GENERICENUMVALUEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setXMLNAME ( String XMLNAME )
   throws DataObjectException {
      checkLoad();
      data.XMLNAME =  markNewValue(
	data.XMLNAME, XMLNAME , 0, XMLNAME_MaxLength, false );
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Set XMLNAME of the GENERICENUMVALUEDEFINITION
    *
    * @param XMLNAME of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void setXMLNAME ( String XMLNAME, org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOSetAttrXMLNAMEAccess( XMLNAME, usr );
      setXMLNAME( XMLNAME );
   }
   /**
    * Ensure that the given user is allowed to update the attribute
    *
    * @param XMLNAME of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOSetAttrXMLNAMEAccess( String XMLNAME, org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOSetAttrXMLNAMEAccess( XMLNAME, usr )) throw new AccessRightException( "No access", usr, "SetAttr", this, null, "XMLNAME", null, null, "String", null);
   }
   /**
    * Check whether the given user is allowed to update the attribute
    *
    * @param XMLNAME of the GENERICENUMVALUEDEFINITION
    * @param usr The user for security check
    * @return Whether the given user is allowed to update the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOSetAttrXMLNAMEAccess( String XMLNAME, org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	try {
	checkLoad();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOSetAttrXMLNAMEAccess/checkLoad !", e, usr, "SetAttr", this, null, "XMLNAME", null, null, "String", null);
	}
	return hasDOSetAttrAccess( "org.webdocwf.util.genericstore.data.EnumValueDefinitionDO:XMLNAME", data.XMLNAME,XMLNAME,usr );
   }
// end of WebDocWf extension for DODS row instance security
   

    /**
     * Protected constructor.
     *
     * @param rs
     *   Result set from which to obtain product data.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    protected EnumValueDefinitionDO(ResultSet rs)
            throws SQLException, ObjectIdException, DataObjectException
 	    , DatabaseManagerException
    {
        super(rs);
	initFromResultSet( rs );
//	super.init( rs );
    }

    /**
     * initFromResultSet initializes the data members from GENERICENUMVALUEDEFINITION.
     * This code was separated from the ResultSet constructor
     * so that createExisting(ResultSet) could handle VIEWs.
     */
    private void initFromResultSet( ResultSet rs )
            throws SQLException, ObjectIdException, DataObjectException
 	    , DatabaseManagerException
    {
	// Constructing a DO from a ResultSet means we definitely need the 
	// DataStruct ready for the setXxx methods invoked below.
	data = new EnumValueDefinitionDataStruct ();
 
	// writeMemberStuff uses the ResultSetExtraction.template
	// to build up the value for this tag:
	// the value is a series of calls to the DO set methods.

	
	setENUMTYPEDEFINITIONOID( 
	    org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO.createExisting( 
		rs.getBigDecimal( 
// WebDocWf bug fix
// The following line has been changed:
			"ENUMTYPEDEFINITIONOID" )
// before: "ENUMTYPEDEFINITIONOID" , 0 )
// end of WebDocWf bug fix
	     )
	);
	
	
	setBEGINSTATE( 
	    
		rs.getBoolean( 
// WebDocWf bug fix
// The following line has been changed:
			"BEGINSTATE" )
// before: "BEGINSTATE" , 0 )
// end of WebDocWf bug fix
	    
	);
	
	
	setENDSTATE( 
	    
		rs.getBoolean( 
// WebDocWf bug fix
// The following line has been changed:
			"ENDSTATE" )
// before: "ENDSTATE" , 0 )
// end of WebDocWf bug fix
	    
	);
	
	
	setLONGNAME( 
	    
		rs.getString( 
// WebDocWf bug fix
// The following line has been changed:
			"LONGNAME" )
// before: "LONGNAME" , 0 )
// end of WebDocWf bug fix
	    
	);
	
	
	setSHORTNAME( 
	    
		rs.getString( 
// WebDocWf bug fix
// The following line has been changed:
			"SHORTNAME" )
// before: "SHORTNAME" , 0 )
// end of WebDocWf bug fix
	    
	);
	
	
	setKEYVALUE( 
	    
		rs.getString( 
// WebDocWf bug fix
// The following line has been changed:
			"KEYVALUE" )
// before: "KEYVALUE" , 0 )
// end of WebDocWf bug fix
	    
	);
	
	
	setXMLNAME( 
	    
		rs.getString( 
// WebDocWf bug fix
// The following line has been changed:
			"XMLNAME" )
// before: "XMLNAME" , 0 )
// end of WebDocWf bug fix
	    
	);
	

 
        markClean();
	
	
    }        


    

    

    private int[] param = null;

    /**
     * Prepares the statement used to insert this object
     * into the database.
     * @param conn the database connection.
     * @return the insert statement.
     * @exception java.sql.SQLException if an error occurs.
     */
    public PreparedStatement getInsertStatement(DBConnection conn)
            throws SQLException {
	/* 
	 * It would probably be better to have CoreDO implement
	 * 	void addToCache(CoreDO DO) {}
	 * and have each DO that has caching enabled override it as
	 *      void addToCache(CoreDO DO) { cache.put( DO.getOId(), DO ); }
	 * and change CoreDO to invoke addToCache()
	 * when it invokes getInsertStatement().
	 */
      
	

        ObjectId oid;

        PreparedStatement stmt = conn.prepareStatement( 
	    "insert into GENERICENUMVALUEDEFINITION ( ENUMTYPEDEFINITIONOID, BEGINSTATE, ENDSTATE, LONGNAME, SHORTNAME, KEYVALUE, XMLNAME, " + getOIdColumnName() + ", " + getVersionColumnName() + " ) values ( ?, ?, ?, ?, ?, ?, ?, ?, ? )" );

	param = new int[1]; param[0] = 1;
	// writeMemberStuff uses the JDBCsetCalls.template
	// to build up the value for this tag:
	// the value is a series of calls to setPrepStmtParam_TYPE methods.
	// Those methods are defined in GenericDO.
	try {
	    setPrepStmtParam_DO( stmt, param,
		getENUMTYPEDEFINITIONOID() );
	    setPrepStmtParam_boolean( stmt, param,
		getBEGINSTATE() );
	    setPrepStmtParam_boolean( stmt, param,
		getENDSTATE() );
	    setPrepStmtParam_String( stmt, param,
		getLONGNAME() );
	    setPrepStmtParam_String( stmt, param,
		getSHORTNAME() );
	    setPrepStmtParam_String( stmt, param,
		getKEYVALUE() );
	    setPrepStmtParam_String( stmt, param,
		getXMLNAME() );


	    /* The ObjecId/Version columns form the primary key.  */
	    setPrepStmtParam_BigDecimal( stmt, param, getOId().toBigDecimal() );
	    setPrepStmtParam_int(        stmt, param, getNewVersion() );

	} catch ( Exception e ) {
	    throw new SQLException( "Data Object error: " + e.getMessage() );
	}

        return stmt;
    }

    /**
     * Prepares the statement used to update this object
     * in the database.
     * @param conn the database connection
     * @return the update statement.
     * @exception java.sql.SQLException if an error occurs.
     */
    public PreparedStatement getUpdateStatement(DBConnection conn)
            throws SQLException {

        ObjectId oid;

        PreparedStatement stmt = conn.prepareStatement(
	    "update GENERICENUMVALUEDEFINITION set " + getVersionColumnName() + " = ?, ENUMTYPEDEFINITIONOID = ?, BEGINSTATE = ?, ENDSTATE = ?, LONGNAME = ?, SHORTNAME = ?, KEYVALUE = ?, XMLNAME = ? " +
	    "where " + getOIdColumnName() + " = ? and " + getVersionColumnName() + " = ?" );

	param = new int[1]; param[0] = 1;
	//int[] param = {1};
	// writeMemberStuff builds up the value for this tag:
	// the value is a series of calls to setPrepStmtParam_TYPE methods.
	// Those methods are defined below.
	try {
	    setPrepStmtParam_int( stmt, param, getNewVersion() );
	    setPrepStmtParam_DO( stmt, param,
		getENUMTYPEDEFINITIONOID() );
	    setPrepStmtParam_boolean( stmt, param,
		getBEGINSTATE() );
	    setPrepStmtParam_boolean( stmt, param,
		getENDSTATE() );
	    setPrepStmtParam_String( stmt, param,
		getLONGNAME() );
	    setPrepStmtParam_String( stmt, param,
		getSHORTNAME() );
	    setPrepStmtParam_String( stmt, param,
		getKEYVALUE() );
	    setPrepStmtParam_String( stmt, param,
		getXMLNAME() );


	    /* When updating a persistent object, the UPDATE_WHERE_CLAUSE tag
	     * used to build the SQL WHERE clause (above) uses the 
	     * DO's ObjectId and Version to locate the correct row in
	     * the database table.
	     */
	    setPrepStmtParam_BigDecimal( stmt, param, getOId().toBigDecimal() );
	    setPrepStmtParam_int(        stmt, param, getVersion() );

	} catch ( Exception e ) {
	    throw new SQLException( "Data Object error: " + e.getMessage() );
	}

        return stmt;
    }

    /**
     * Prepares the statement used to delete this object
     * from the database.
     * @param conn the database connection
     * @return the delete statement.
     * @exception java.sql.SQLException if an error occurs.
     */
    public PreparedStatement getDeleteStatement(DBConnection conn)
            throws SQLException {
        
	cache.remove( getOId().toString() );
	

        String sql =
            "delete from GENERICENUMVALUEDEFINITION \n" +
            "where " + getOIdColumnName() + " = ?";
        PreparedStatement stmt = conn.prepareStatement(sql);
        stmt.setBigDecimal(1, getOId().toBigDecimal());
        return stmt;
    }

    

    /*
     * toString - for debugging
     */
/*
    public String toString(){
	String str = "EnumValueDefinitionDO:";
	ObjectId oid = getOId();
	String id = "virgin";
	if ( null != oid ) 
	    id = oid.toString();
	str += " OID=" + id;
	if ( null != data ) 
	    str = str + "\n" + indent + "ENUMTYPEDEFINITIONOID=" + ( null == data.ENUMTYPEDEFINITIONOID ? null  : data.ENUMTYPEDEFINITIONOID.toString( indentCount + 1 ) )
+ "\n" + indent + "BEGINSTATE=" + data.BEGINSTATE
+ "\n" + indent + "ENDSTATE=" + data.ENDSTATE
+ "\n" + indent + "LONGNAME=" + data.LONGNAME
+ "\n" + indent + "SHORTNAME=" + data.SHORTNAME
+ "\n" + indent + "KEYVALUE=" + data.KEYVALUE
+ "\n" + indent + "XMLNAME=" + data.XMLNAME
;
        return str + "; " + super.toString();
    }
*/

    /*
     * toString - for debugging
     */
    public String toString(){
        return toString( 1 );
    }
    public String toString( int indentCount ){
        String indent = "";
        for ( int i = 0; i < indentCount; i++ ) {
            indent += ". ";
        }
        String str = indent + "EnumValueDefinitionDO:";
        ObjectId oid = getOId();
        String id = "virgin";
        if ( null != oid )
            id = oid.toString();
        str += " OID=" + id;
        if ( null != data )
            str = str + "\n" + indent + "ENUMTYPEDEFINITIONOID=" + ( null == data.ENUMTYPEDEFINITIONOID ? null  : data.ENUMTYPEDEFINITIONOID.toString( indentCount + 1 ) )
+ "\n" + indent + "BEGINSTATE=" + data.BEGINSTATE
+ "\n" + indent + "ENDSTATE=" + data.ENDSTATE
+ "\n" + indent + "LONGNAME=" + data.LONGNAME
+ "\n" + indent + "SHORTNAME=" + data.SHORTNAME
+ "\n" + indent + "KEYVALUE=" + data.KEYVALUE
+ "\n" + indent + "XMLNAME=" + data.XMLNAME
;
        return str + "\n" + indent + "SUPER=" + super.toString( indentCount );
        //return str;
    }

    
    /**
     * Get array of AttributeEnumValueDO objects that refer to this DO.
     *
     * @return array of AttributeEnumValueDO objects.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     */
    public org.webdocwf.util.genericstore.data.AttributeEnumValueDO[] getAttributeEnumValueDOArray () 
    throws DataObjectException, QueryException {
	org.webdocwf.util.genericstore.data.AttributeEnumValueDO[] ret = null;
	try {
	    org.webdocwf.util.genericstore.data.AttributeEnumValueQuery q = new org.webdocwf.util.genericstore.data.AttributeEnumValueQuery();
	    q.setQueryENUMVALUEDEFINITIONOID( this );
	    ret = q.getDOArray();
	} catch ( NonUniqueQueryException e ) { 
	    throw new DataObjectException( 
		"INTERNAL ERROR: unexpected NonUniqueQueryException" );
	} finally {
	    if ( null == ret )
		ret = new org.webdocwf.util.genericstore.data.AttributeEnumValueDO[ 0 ];
	}
	return ret;
    }

    /**
     * Get the single AttributeEnumValueDO object
     * that refers to this DO.
     *
     * @return AttributeEnumValueDO object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     * @exception NonUniqueQueryException
     *   If more than one AttributeEnumValueDO object was found.
     */
    public org.webdocwf.util.genericstore.data.AttributeEnumValueDO getAttributeEnumValueDO () 
    throws DataObjectException, QueryException, NonUniqueQueryException {
	org.webdocwf.util.genericstore.data.AttributeEnumValueQuery q = new org.webdocwf.util.genericstore.data.AttributeEnumValueQuery();
	q.setQueryENUMVALUEDEFINITIONOID( this );
	q.requireUniqueInstance();
	return q.getNextDO();
    }

    /**
     * Add (set & commit) a AttributeEnumValueDO object that refers to this DO.
     *
     * @param referrer AttributeEnumValueDO to be set to point to this DO and committed.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void addAttributeEnumValueDO( org.webdocwf.util.genericstore.data.AttributeEnumValueDO referrer )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for DODS row instance security
// The following line has been changed:
        addAttributeEnumValueDO( referrer, (DBTransaction)null );
// before:        addAttributeEnumValueDO( referrer, null );
// end of WebDocWf extension for DODS row instance security
    }
 
 
    /**
     * Add (set & commit) a AttributeEnumValueDO object that refers to this DO.
     *
     * @param referrer AttributeEnumValueDO to be set to point to this DO and committed.
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void addAttributeEnumValueDO( org.webdocwf.util.genericstore.data.AttributeEnumValueDO referrer, DBTransaction tran )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
        referrer.setENUMVALUEDEFINITIONOID( this );
        referrer.commit( tran );
    }

 
    /**
     * Remove (delete) a AttributeEnumValueDO object that refers to this DO.
     *
     * @param referrer AttributeEnumValueDO to be deleted.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void removeAttributeEnumValueDO( org.webdocwf.util.genericstore.data.AttributeEnumValueDO referrer )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for DODS row instance security
// The following line has been changed:
        removeAttributeEnumValueDO( referrer, (DBTransaction)null );
// before:        removeAttributeEnumValueDO( referrer, null );
// end of WebDocWf extension for DODS row instance security
    }
 
 
    /**
     * Remove (delete) a AttributeEnumValueDO object that refers to this DO.
     *
     * @param referrer AttributeEnumValueDO to be deleted.
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void removeAttributeEnumValueDO( org.webdocwf.util.genericstore.data.AttributeEnumValueDO referrer, DBTransaction tran )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
	EnumValueDefinitionDO referred = referrer.getENUMVALUEDEFINITIONOID();
	String referredHandle = referred.getHandle();
	String mydoHandle = this.getHandle();
	if ( null == referredHandle || null == mydoHandle || 
	     ( ! referredHandle.equals( mydoHandle ) ) ) {
	    throw new DataObjectException( "Object " + referrer +
		" does not refer to object " + this +
		", cannot be removed this way." );
	}
        referrer.delete( tran );
    }
    // WebDocWF extension for DODS row instance security
    // The following lines have been added:
    /**
     * Get array of AttributeEnumValueDO objects that refer to this DO.
     *
     * @param usr The user for security checks
     * @return array of AttributeEnumValueDO objects.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     * @exception AccessException
     *   The user is not allowed to create a query for 
     *   org.webdocwf.util.genericstore.data.AttributeEnumValue or 
     *   to access the foreign key attribute ENUMVALUEDEFINITIONOID.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public org.webdocwf.util.genericstore.data.AttributeEnumValueDO[] getAttributeEnumValueDOArray ( org.webdocwf.dods.access.User usr ) 
    throws DataObjectException, QueryException, AccessException {
	org.webdocwf.util.genericstore.data.AttributeEnumValueDO[] ret = null;
	try {
	    org.webdocwf.util.genericstore.data.AttributeEnumValueQuery q = new org.webdocwf.util.genericstore.data.AttributeEnumValueQuery( usr );
	    q.setQueryENUMVALUEDEFINITIONOID( this, usr );
	    ret = q.getDOArray();
	} catch ( NonUniqueQueryException e ) { 
	    throw new DataObjectException( 
		"INTERNAL ERROR: unexpected NonUniqueQueryException" );
	} finally {
	    if ( null == ret )
		ret = new org.webdocwf.util.genericstore.data.AttributeEnumValueDO[ 0 ];
	}
	return ret;
    }
    /**
     * Get the single AttributeEnumValueDO object
     * that refers to this DO.
     *
     * @param usr The user for security checks
     * @return AttributeEnumValueDO object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     * @exception NonUniqueQueryException
     *   If more than one AttributeEnumValueDO object was found.
     * @exception AccessException
     *   The user is not allowed to create a query for 
     *   org.webdocwf.util.genericstore.data.AttributeEnumValue or 
     *   to access the foreign key attribute ENUMVALUEDEFINITIONOID.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public org.webdocwf.util.genericstore.data.AttributeEnumValueDO getAttributeEnumValueDO ( org.webdocwf.dods.access.User usr ) 
    throws DataObjectException, QueryException, NonUniqueQueryException, AccessException {
	org.webdocwf.util.genericstore.data.AttributeEnumValueQuery q = new org.webdocwf.util.genericstore.data.AttributeEnumValueQuery( usr );
	q.setQueryENUMVALUEDEFINITIONOID( this, usr );
	q.requireUniqueInstance();
	return q.getNextDO();
    }
   /**
     * Add (set & commit) a AttributeEnumValueDO object that refers to this DO.
     *
     * @param referrer AttributeEnumValueDO to be set to point to this DO and committed.
     * @param usr The user for security checks
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void addAttributeEnumValueDO( org.webdocwf.util.genericstore.data.AttributeEnumValueDO referrer, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
        addAttributeEnumValueDO( referrer, null, usr );
    }
 
 
    /**
     * Add (set & commit) a AttributeEnumValueDO object that refers to this DO.
     *
     * @param referrer AttributeEnumValueDO to be set to point to this DO and committed.
     * @param usr The user for security checks
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void addAttributeEnumValueDO( org.webdocwf.util.genericstore.data.AttributeEnumValueDO referrer, DBTransaction tran, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
        referrer.setENUMVALUEDEFINITIONOID( this, usr );
        referrer.commit( tran );
    }

 
    /**
     * Remove (delete) a AttributeEnumValueDO object that refers to this DO.
     *
     * @param referrer AttributeEnumValueDO to be deleted.
     * @param usr The user for security checks
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void removeAttributeEnumValueDO( org.webdocwf.util.genericstore.data.AttributeEnumValueDO referrer, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
        removeAttributeEnumValueDO( referrer, null, usr );
    }
 
 
    /**
     * Remove (delete) a AttributeEnumValueDO object that refers to this DO.
     *
     * @param referrer AttributeEnumValueDO to be deleted.
     * @param usr The user for security checks
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void removeAttributeEnumValueDO( org.webdocwf.util.genericstore.data.AttributeEnumValueDO referrer, DBTransaction tran, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
	EnumValueDefinitionDO referred = referrer.getENUMVALUEDEFINITIONOID( usr );
	String referredHandle = referred.getHandle( usr );
	String mydoHandle = this.getHandle( usr );
	if ( null == referredHandle || null == mydoHandle || 
	     ( ! referredHandle.equals( mydoHandle ) ) ) {
	    throw new DataObjectException( "Object " + referrer +
		" does not refer to object " + this +
		", cannot be removed this way." );
	}
        referrer.delete( tran, usr );
    }
// end of WebDocWf extension for DODS row instance security

    // WebDocWF extension for DODS row counter
    // The following lines have been added:
    /**
     * Get the number of AttributeEnumValueDOs that refer to this DO.
     * via ENUMVALUEDEFINITIONOID
     *
     * @return The number of objects that refer to this DO
     *
     * @exception DataObjectException If object is not found in the database.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public int getAttributeEnumValueDOArrayCount () 
    throws DataObjectException, QueryException, NonUniqueQueryException, SQLException, DatabaseManagerException {
	int ret = 0;
    org.webdocwf.util.genericstore.data.AttributeEnumValueQuery q = new org.webdocwf.util.genericstore.data.AttributeEnumValueQuery();
    q.setQueryENUMVALUEDEFINITIONOID( this );
    ret = q.getCount();
	return ret;
    }

    /**
     * Get the number of AttributeEnumValueDOs that refer to this DO.
     * via ENUMVALUEDEFINITIONOID
     *
     * @param usr The user for security checks
     * @return The number of objects that refer to this DO
     *
     * @exception DataObjectException If object is not found in the database.
     * @exception AccessException
     *   The user is not allowed to create a query for 
     *   org.webdocwf.util.genericstore.data.AttributeEnumValue or 
     *   to access the foreign key attribute ENUMVALUEDEFINITIONOID.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public int getAttributeEnumValueDOArrayCount ( org.webdocwf.dods.access.User usr ) 
    throws DataObjectException, QueryException, NonUniqueQueryException, SQLException, DatabaseManagerException, AccessException {
	int ret = 0;
    org.webdocwf.util.genericstore.data.AttributeEnumValueQuery q = new org.webdocwf.util.genericstore.data.AttributeEnumValueQuery(usr);
    q.setQueryENUMVALUEDEFINITIONOID( this, usr );
    ret = q.getCount();
	return ret;
    }
    // end of WebDocWF extension for DODS row counter

    /**
     * Get array of StateTransitionDO objects that refer to this DO.
     *
     * @return array of StateTransitionDO objects.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     */
    public org.webdocwf.util.genericstore.data.StateTransitionDO[] getStateTransitionDOArray_ENUMVALUEDEFINITIONFROMOID () 
    throws DataObjectException, QueryException {
	org.webdocwf.util.genericstore.data.StateTransitionDO[] ret = null;
	try {
	    org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery();
	    q.setQueryENUMVALUEDEFINITIONFROMOID( this );
	    ret = q.getDOArray();
	} catch ( NonUniqueQueryException e ) { 
	    throw new DataObjectException( 
		"INTERNAL ERROR: unexpected NonUniqueQueryException" );
	} finally {
	    if ( null == ret )
		ret = new org.webdocwf.util.genericstore.data.StateTransitionDO[ 0 ];
	}
	return ret;
    }

    /**
     * Get the single StateTransitionDO object
     * that refers to this DO.
     *
     * @return StateTransitionDO object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     * @exception NonUniqueQueryException
     *   If more than one StateTransitionDO object was found.
     */
    public org.webdocwf.util.genericstore.data.StateTransitionDO getStateTransitionDO_ENUMVALUEDEFINITIONFROMOID () 
    throws DataObjectException, QueryException, NonUniqueQueryException {
	org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery();
	q.setQueryENUMVALUEDEFINITIONFROMOID( this );
	q.requireUniqueInstance();
	return q.getNextDO();
    }

    /**
     * Add (set & commit) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be set to point to this DO and committed.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void addStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for DODS row instance security
// The following line has been changed:
        addStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( referrer, (DBTransaction)null );
// before:        addStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( referrer, null );
// end of WebDocWf extension for DODS row instance security
    }
 
 
    /**
     * Add (set & commit) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be set to point to this DO and committed.
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void addStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, DBTransaction tran )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
        referrer.setENUMVALUEDEFINITIONFROMOID( this );
        referrer.commit( tran );
    }

 
    /**
     * Remove (delete) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be deleted.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void removeStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for DODS row instance security
// The following line has been changed:
        removeStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( referrer, (DBTransaction)null );
// before:        removeStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( referrer, null );
// end of WebDocWf extension for DODS row instance security
    }
 
 
    /**
     * Remove (delete) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be deleted.
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void removeStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, DBTransaction tran )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
	EnumValueDefinitionDO referred = referrer.getENUMVALUEDEFINITIONFROMOID();
	String referredHandle = referred.getHandle();
	String mydoHandle = this.getHandle();
	if ( null == referredHandle || null == mydoHandle || 
	     ( ! referredHandle.equals( mydoHandle ) ) ) {
	    throw new DataObjectException( "Object " + referrer +
		" does not refer to object " + this +
		", cannot be removed this way." );
	}
        referrer.delete( tran );
    }
    // WebDocWF extension for DODS row instance security
    // The following lines have been added:
    /**
     * Get array of StateTransitionDO objects that refer to this DO.
     *
     * @param usr The user for security checks
     * @return array of StateTransitionDO objects.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     * @exception AccessException
     *   The user is not allowed to create a query for 
     *   org.webdocwf.util.genericstore.data.StateTransition or 
     *   to access the foreign key attribute ENUMVALUEDEFINITIONFROMOID.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public org.webdocwf.util.genericstore.data.StateTransitionDO[] getStateTransitionDOArray_ENUMVALUEDEFINITIONFROMOID ( org.webdocwf.dods.access.User usr ) 
    throws DataObjectException, QueryException, AccessException {
	org.webdocwf.util.genericstore.data.StateTransitionDO[] ret = null;
	try {
	    org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery( usr );
	    q.setQueryENUMVALUEDEFINITIONFROMOID( this, usr );
	    ret = q.getDOArray();
	} catch ( NonUniqueQueryException e ) { 
	    throw new DataObjectException( 
		"INTERNAL ERROR: unexpected NonUniqueQueryException" );
	} finally {
	    if ( null == ret )
		ret = new org.webdocwf.util.genericstore.data.StateTransitionDO[ 0 ];
	}
	return ret;
    }
    /**
     * Get the single StateTransitionDO object
     * that refers to this DO.
     *
     * @param usr The user for security checks
     * @return StateTransitionDO object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     * @exception NonUniqueQueryException
     *   If more than one StateTransitionDO object was found.
     * @exception AccessException
     *   The user is not allowed to create a query for 
     *   org.webdocwf.util.genericstore.data.StateTransition or 
     *   to access the foreign key attribute ENUMVALUEDEFINITIONFROMOID.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public org.webdocwf.util.genericstore.data.StateTransitionDO getStateTransitionDO_ENUMVALUEDEFINITIONFROMOID ( org.webdocwf.dods.access.User usr ) 
    throws DataObjectException, QueryException, NonUniqueQueryException, AccessException {
	org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery( usr );
	q.setQueryENUMVALUEDEFINITIONFROMOID( this, usr );
	q.requireUniqueInstance();
	return q.getNextDO();
    }
   /**
     * Add (set & commit) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be set to point to this DO and committed.
     * @param usr The user for security checks
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void addStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
        addStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( referrer, null, usr );
    }
 
 
    /**
     * Add (set & commit) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be set to point to this DO and committed.
     * @param usr The user for security checks
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void addStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, DBTransaction tran, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
        referrer.setENUMVALUEDEFINITIONFROMOID( this, usr );
        referrer.commit( tran );
    }

 
    /**
     * Remove (delete) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be deleted.
     * @param usr The user for security checks
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void removeStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
        removeStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( referrer, null, usr );
    }
 
 
    /**
     * Remove (delete) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be deleted.
     * @param usr The user for security checks
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void removeStateTransitionDO_ENUMVALUEDEFINITIONFROMOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, DBTransaction tran, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
	EnumValueDefinitionDO referred = referrer.getENUMVALUEDEFINITIONFROMOID( usr );
	String referredHandle = referred.getHandle( usr );
	String mydoHandle = this.getHandle( usr );
	if ( null == referredHandle || null == mydoHandle || 
	     ( ! referredHandle.equals( mydoHandle ) ) ) {
	    throw new DataObjectException( "Object " + referrer +
		" does not refer to object " + this +
		", cannot be removed this way." );
	}
        referrer.delete( tran, usr );
    }
// end of WebDocWf extension for DODS row instance security

    // WebDocWF extension for DODS row counter
    // The following lines have been added:
    /**
     * Get the number of StateTransitionDOs that refer to this DO.
     * via ENUMVALUEDEFINITIONFROMOID
     *
     * @return The number of objects that refer to this DO
     *
     * @exception DataObjectException If object is not found in the database.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public int getStateTransitionDOArray_ENUMVALUEDEFINITIONFROMOIDCount () 
    throws DataObjectException, QueryException, NonUniqueQueryException, SQLException, DatabaseManagerException {
	int ret = 0;
    org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery();
    q.setQueryENUMVALUEDEFINITIONFROMOID( this );
    ret = q.getCount();
	return ret;
    }

    /**
     * Get the number of StateTransitionDOs that refer to this DO.
     * via ENUMVALUEDEFINITIONFROMOID
     *
     * @param usr The user for security checks
     * @return The number of objects that refer to this DO
     *
     * @exception DataObjectException If object is not found in the database.
     * @exception AccessException
     *   The user is not allowed to create a query for 
     *   org.webdocwf.util.genericstore.data.StateTransition or 
     *   to access the foreign key attribute ENUMVALUEDEFINITIONFROMOID.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public int getStateTransitionDOArray_ENUMVALUEDEFINITIONFROMOIDCount ( org.webdocwf.dods.access.User usr ) 
    throws DataObjectException, QueryException, NonUniqueQueryException, SQLException, DatabaseManagerException, AccessException {
	int ret = 0;
    org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery(usr);
    q.setQueryENUMVALUEDEFINITIONFROMOID( this, usr );
    ret = q.getCount();
	return ret;
    }
    // end of WebDocWF extension for DODS row counter

    /**
     * Get array of StateTransitionDO objects that refer to this DO.
     *
     * @return array of StateTransitionDO objects.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     */
    public org.webdocwf.util.genericstore.data.StateTransitionDO[] getStateTransitionDOArray_ENUMVALUEDEFINITIONTOOID () 
    throws DataObjectException, QueryException {
	org.webdocwf.util.genericstore.data.StateTransitionDO[] ret = null;
	try {
	    org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery();
	    q.setQueryENUMVALUEDEFINITIONTOOID( this );
	    ret = q.getDOArray();
	} catch ( NonUniqueQueryException e ) { 
	    throw new DataObjectException( 
		"INTERNAL ERROR: unexpected NonUniqueQueryException" );
	} finally {
	    if ( null == ret )
		ret = new org.webdocwf.util.genericstore.data.StateTransitionDO[ 0 ];
	}
	return ret;
    }

    /**
     * Get the single StateTransitionDO object
     * that refers to this DO.
     *
     * @return StateTransitionDO object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     * @exception NonUniqueQueryException
     *   If more than one StateTransitionDO object was found.
     */
    public org.webdocwf.util.genericstore.data.StateTransitionDO getStateTransitionDO_ENUMVALUEDEFINITIONTOOID () 
    throws DataObjectException, QueryException, NonUniqueQueryException {
	org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery();
	q.setQueryENUMVALUEDEFINITIONTOOID( this );
	q.requireUniqueInstance();
	return q.getNextDO();
    }

    /**
     * Add (set & commit) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be set to point to this DO and committed.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void addStateTransitionDO_ENUMVALUEDEFINITIONTOOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for DODS row instance security
// The following line has been changed:
        addStateTransitionDO_ENUMVALUEDEFINITIONTOOID( referrer, (DBTransaction)null );
// before:        addStateTransitionDO_ENUMVALUEDEFINITIONTOOID( referrer, null );
// end of WebDocWf extension for DODS row instance security
    }
 
 
    /**
     * Add (set & commit) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be set to point to this DO and committed.
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void addStateTransitionDO_ENUMVALUEDEFINITIONTOOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, DBTransaction tran )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
        referrer.setENUMVALUEDEFINITIONTOOID( this );
        referrer.commit( tran );
    }

 
    /**
     * Remove (delete) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be deleted.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void removeStateTransitionDO_ENUMVALUEDEFINITIONTOOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for DODS row instance security
// The following line has been changed:
        removeStateTransitionDO_ENUMVALUEDEFINITIONTOOID( referrer, (DBTransaction)null );
// before:        removeStateTransitionDO_ENUMVALUEDEFINITIONTOOID( referrer, null );
// end of WebDocWf extension for DODS row instance security
    }
 
 
    /**
     * Remove (delete) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be deleted.
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     */
    public void removeStateTransitionDO_ENUMVALUEDEFINITIONTOOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, DBTransaction tran )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
	EnumValueDefinitionDO referred = referrer.getENUMVALUEDEFINITIONTOOID();
	String referredHandle = referred.getHandle();
	String mydoHandle = this.getHandle();
	if ( null == referredHandle || null == mydoHandle || 
	     ( ! referredHandle.equals( mydoHandle ) ) ) {
	    throw new DataObjectException( "Object " + referrer +
		" does not refer to object " + this +
		", cannot be removed this way." );
	}
        referrer.delete( tran );
    }
    // WebDocWF extension for DODS row instance security
    // The following lines have been added:
    /**
     * Get array of StateTransitionDO objects that refer to this DO.
     *
     * @param usr The user for security checks
     * @return array of StateTransitionDO objects.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     * @exception AccessException
     *   The user is not allowed to create a query for 
     *   org.webdocwf.util.genericstore.data.StateTransition or 
     *   to access the foreign key attribute ENUMVALUEDEFINITIONTOOID.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public org.webdocwf.util.genericstore.data.StateTransitionDO[] getStateTransitionDOArray_ENUMVALUEDEFINITIONTOOID ( org.webdocwf.dods.access.User usr ) 
    throws DataObjectException, QueryException, AccessException {
	org.webdocwf.util.genericstore.data.StateTransitionDO[] ret = null;
	try {
	    org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery( usr );
	    q.setQueryENUMVALUEDEFINITIONTOOID( this, usr );
	    ret = q.getDOArray();
	} catch ( NonUniqueQueryException e ) { 
	    throw new DataObjectException( 
		"INTERNAL ERROR: unexpected NonUniqueQueryException" );
	} finally {
	    if ( null == ret )
		ret = new org.webdocwf.util.genericstore.data.StateTransitionDO[ 0 ];
	}
	return ret;
    }
    /**
     * Get the single StateTransitionDO object
     * that refers to this DO.
     *
     * @param usr The user for security checks
     * @return StateTransitionDO object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception QueryException
     *   If an error occured while building the query before execution.
     * @exception NonUniqueQueryException
     *   If more than one StateTransitionDO object was found.
     * @exception AccessException
     *   The user is not allowed to create a query for 
     *   org.webdocwf.util.genericstore.data.StateTransition or 
     *   to access the foreign key attribute ENUMVALUEDEFINITIONTOOID.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public org.webdocwf.util.genericstore.data.StateTransitionDO getStateTransitionDO_ENUMVALUEDEFINITIONTOOID ( org.webdocwf.dods.access.User usr ) 
    throws DataObjectException, QueryException, NonUniqueQueryException, AccessException {
	org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery( usr );
	q.setQueryENUMVALUEDEFINITIONTOOID( this, usr );
	q.requireUniqueInstance();
	return q.getNextDO();
    }
   /**
     * Add (set & commit) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be set to point to this DO and committed.
     * @param usr The user for security checks
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void addStateTransitionDO_ENUMVALUEDEFINITIONTOOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
        addStateTransitionDO_ENUMVALUEDEFINITIONTOOID( referrer, null, usr );
    }
 
 
    /**
     * Add (set & commit) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be set to point to this DO and committed.
     * @param usr The user for security checks
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void addStateTransitionDO_ENUMVALUEDEFINITIONTOOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, DBTransaction tran, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
        referrer.setENUMVALUEDEFINITIONTOOID( this, usr );
        referrer.commit( tran );
    }

 
    /**
     * Remove (delete) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be deleted.
     * @param usr The user for security checks
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void removeStateTransitionDO_ENUMVALUEDEFINITIONTOOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
        removeStateTransitionDO_ENUMVALUEDEFINITIONTOOID( referrer, null, usr );
    }
 
 
    /**
     * Remove (delete) a StateTransitionDO object that refers to this DO.
     *
     * @param referrer StateTransitionDO to be deleted.
     * @param usr The user for security checks
     *
     * @param tran The transaction to be used for the commit.
     * If null, a new transaction is created.
     *
     * @exception DatabaseManagerException if could not create a transaction
     * @exception java.sql.SQLException if any SQL errors occur.
     * @exception DataObjectException If object is not found in the database.
     *
     * WebDocWf extension
     *
     */
    public void removeStateTransitionDO_ENUMVALUEDEFINITIONTOOID( org.webdocwf.util.genericstore.data.StateTransitionDO referrer, DBTransaction tran, org.webdocwf.dods.access.User usr )
    throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException, AccessException {
	EnumValueDefinitionDO referred = referrer.getENUMVALUEDEFINITIONTOOID( usr );
	String referredHandle = referred.getHandle( usr );
	String mydoHandle = this.getHandle( usr );
	if ( null == referredHandle || null == mydoHandle || 
	     ( ! referredHandle.equals( mydoHandle ) ) ) {
	    throw new DataObjectException( "Object " + referrer +
		" does not refer to object " + this +
		", cannot be removed this way." );
	}
        referrer.delete( tran, usr );
    }
// end of WebDocWf extension for DODS row instance security

    // WebDocWF extension for DODS row counter
    // The following lines have been added:
    /**
     * Get the number of StateTransitionDOs that refer to this DO.
     * via ENUMVALUEDEFINITIONTOOID
     *
     * @return The number of objects that refer to this DO
     *
     * @exception DataObjectException If object is not found in the database.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public int getStateTransitionDOArray_ENUMVALUEDEFINITIONTOOIDCount () 
    throws DataObjectException, QueryException, NonUniqueQueryException, SQLException, DatabaseManagerException {
	int ret = 0;
    org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery();
    q.setQueryENUMVALUEDEFINITIONTOOID( this );
    ret = q.getCount();
	return ret;
    }

    /**
     * Get the number of StateTransitionDOs that refer to this DO.
     * via ENUMVALUEDEFINITIONTOOID
     *
     * @param usr The user for security checks
     * @return The number of objects that refer to this DO
     *
     * @exception DataObjectException If object is not found in the database.
     * @exception AccessException
     *   The user is not allowed to create a query for 
     *   org.webdocwf.util.genericstore.data.StateTransition or 
     *   to access the foreign key attribute ENUMVALUEDEFINITIONTOOID.
     *
     * This is a WebDocWf extension for DODS row instance security
     *
     */
    public int getStateTransitionDOArray_ENUMVALUEDEFINITIONTOOIDCount ( org.webdocwf.dods.access.User usr ) 
    throws DataObjectException, QueryException, NonUniqueQueryException, SQLException, DatabaseManagerException, AccessException {
	int ret = 0;
    org.webdocwf.util.genericstore.data.StateTransitionQuery q = new org.webdocwf.util.genericstore.data.StateTransitionQuery(usr);
    q.setQueryENUMVALUEDEFINITIONTOOID( this, usr );
    ret = q.getCount();
	return ret;
    }
    // end of WebDocWF extension for DODS row counter




    /**
     * A stub method for implementing pre-commit assertions 
     * for this EnumValueDefinitionDO.
     * Implement this stub to throw an RefAssertionException for cases
     * where this object is not valid for writing to the database.
     */
    protected void okToCommit() 
    throws RefAssertionException { }

    /**
     * A stub method for implementing pre-delete assertions 
     * for this EnumValueDefinitionDO.
     * Implement this stub to throw an RefAssertionException for cases
     * where this object is not valid for deletion from the database.
     */
    protected void okToDelete() 
    throws RefAssertionException { }

  /**
   * Inserts/Updates the DO into its table.
   *
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * @deprecated Use save() instead.
   */
  public void commit() 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for generic store
// The following line was put under comments
//    modifyDO( null, false );
// The following lines have been inserted:
    DBTransaction dbt = DODS.getDatabaseManager().createTransaction();

    save(dbt);
    dbt.commit();
    dbt.release();
// end of WebDocWf extension for generic store
  }

  /**
   * Inserts/Updates the DO into its table.
   *
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
  public void save() 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
	save(true);
  }

  /**
   * Inserts/Updates the DO into its table.
   *
   * @param references True if references should be saved with this DO
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
  public void save(boolean references) 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for generic store
// The following line was put under comments
//    modifyDO( null, false, references );
// The following lines have been inserted:
    DBTransaction dbt = DODS.getDatabaseManager().createTransaction();

    save(dbt, references);
    dbt.commit();
    dbt.release();
// end of WebDocWf extension for generic store
  }

  /**
   * Inserts/Updates the DO into its table.
   * The transaction is likely provided by the commit() method of another DO
   * which references this DO.
   * 
   * @param dbt The transaction object to use for this operation.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * @deprecated Use save() instead.
   */
  public void commit(DBTransaction dbt)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for generic store
// The following line has been inserted:
    DBTransaction dbtlocal = dbt;
    if (dbtlocal == null) dbtlocal = DODS.getDatabaseManager().createTransaction();
// The following line has been changed:
    modifyDO( dbtlocal, false );
// before: modifyDO( dbt, false );
// The following line has been inserted:
    super.save(dbtlocal);
// end of WebDocWf extension for generic store
  }

  /**
   * Inserts/Updates the DO into its table.
   * The transaction is likely provided by the commit() method of another DO
   * which references this DO.
   * 
   * @param dbt The transaction object to use for this operation.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
  public void save(DBTransaction dbt)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
	save(dbt, true);
  }

  /**
   * Inserts/Updates the DO into its table.
   * The transaction is likely provided by the commit() method of another DO
   * which references this DO.
   * 
   * @param dbt The transaction object to use for this operation.
   * @param references True if references of this DO should be saved
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
  public void save(DBTransaction dbt, boolean references)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for generic store
// The following line has been inserted:
    DBTransaction dbtlocal = dbt;
    if (dbtlocal == null) dbtlocal = DODS.getDatabaseManager().createTransaction();
// The following line has been changed:
    modifyDO( dbtlocal, false, references );
// before: modifyDO( dbt, false );
// The following line has been inserted:
    super.save(dbtlocal);
// end of WebDocWf extension for generic store
  }

  /**
   * Deletes the DO from its table.
   *
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   */
  public void delete() 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {

// WebDocWf extension for generic store
// The following line was put under comments
//    modifyDO( null, true );
// The following lines have been inserted:
    DBTransaction dbt = DODS.getDatabaseManager().createTransaction();
    delete(dbt);
    dbt.commit();
    dbt.release();
// end of WebDocWf extension for generic store
  }

  /**
   * Deletes the DO from its table.
   * The transaction is likely provided by the delete() method of another DO
   * which references this DO.
   *
   * @param dbt The transaction object to use for this operation.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   */
  public void delete(DBTransaction dbt)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for generic store
// The following lines have been inserted:
    DBTransaction dbtlocal = dbt;
    if (dbtlocal == null) dbtlocal = DODS.getDatabaseManager().createTransaction();
    super.delete(dbtlocal);
// The following line has been changed:
    modifyDO( dbtlocal, true );
// before:    modifyDO( dbt, true );
// end of WebDocWf extension for generic store
  }

      /**
     * A stub method for implementing pre-commit assertions 
     * for the ENUMTYPEDEFINITIONOID data member.
     * Implement this stub to throw an RefAssertionException for cases
     * where ENUMTYPEDEFINITIONOID is not valid for writing to the database.
     */
    protected void okToCommitENUMTYPEDEFINITIONOID( org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO member ) 
    throws RefAssertionException { }

    /**
     * A stub method for implementing pre-delete assertions 
     * for the ENUMTYPEDEFINITIONOID data member.
     * Implement this stub to throw an RefAssertionException for cases
     * where ENUMTYPEDEFINITIONOID is not valid for deletion from the database.
     */
    protected void okToDeleteENUMTYPEDEFINITIONOID( org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO member ) 
    throws RefAssertionException { }



  /**
   * Modifies the DO within its table.
   * Performs recursive commit/delete on referenced DOs;
   * all operations occur within a single transaction
   * to allow rollback in the event of error.
   * Only the creator of the transaction releases it.
   *
   * @param dbt The transaction object to use for this operation.
   * @param delete True if doing a delete, otherwise doing insert/update.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
// WebDocWf extension for save without references
// The following line has been modofied
  protected void modifyDO( DBTransaction dbt, boolean delete)
// before:  protected void modifyDO( DBTransaction dbt, boolean delete )
// end of WebDocWf extension for save without references
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
	modifyDO( dbt, delete, true);
  }
  /**
   * Modifies the DO within its table.
   * Performs recursive commit/delete on referenced DOs;
   * all operations occur within a single transaction
   * to allow rollback in the event of error.
   * Only the creator of the transaction releases it.
   *
   * @param dbt The transaction object to use for this operation.
   * @param delete True if doing a delete, otherwise doing insert/update.
   * @param references True if references should be saved
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
// WebDocWf extension for save without references
// The following line has been modofied
  protected void modifyDO( DBTransaction dbt, boolean delete, boolean references )
// before:  protected void modifyDO( DBTransaction dbt, boolean delete )
// end of WebDocWf extension for save without references
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
    if ( delete )
	okToDelete();
    else
	okToCommit();
    boolean ownTransaction = false;
    try {
      if ( null == dbt ) {
	DatabaseManager dbm = DODS.getDatabaseManager();
        dbt = dbm.createTransaction();      // create a transaction
	ownTransaction = true;
      } 
// WebDocWf fix for circular references
// The following lines have been inserted
	  else
      {
        CoreDO foundDO = dbt.getDO(this);
        if (foundDO!=null) return;
      }
// end of WebDocWf fix for circular references
      if ( null == dbt )
	throw new DatabaseManagerException(
		"DatabaseManager.createTransaction returned null." );
      if ( delete ) {
	  // Code to perform cascading deletes is generated here
	  // if cascading deletes are not supported by the database.      
	  	
	{
	    // perform cascading delete on referring table
	    org.webdocwf.util.genericstore.data.AttributeEnumValueDO[] a = getAttributeEnumValueDOArray();
	    for ( int i = 0; i < a.length; i++ ) {
		a[ i ].delete( dbt );
	    }
	}
	
	
	{
	    // perform cascading delete on referring table
	    org.webdocwf.util.genericstore.data.StateTransitionDO[] a = getStateTransitionDOArray_ENUMVALUEDEFINITIONFROMOID();
	    for ( int i = 0; i < a.length; i++ ) {
		a[ i ].delete( dbt );
	    }
	}
	
	
	{
	    // perform cascading delete on referring table
	    org.webdocwf.util.genericstore.data.StateTransitionDO[] a = getStateTransitionDOArray_ENUMVALUEDEFINITIONTOOID();
	    for ( int i = 0; i < a.length; i++ ) {
		a[ i ].delete( dbt );
	    }
	}
	

	  // The following line keeps the compiler happy 
	  // when the CASCADING_DELETES tag is empty.
          if ( false )
	      throw new QueryException("XXX");
      } else {
// WebDocWf extension for save without references
// The following line has been inserted
	  if (references) {
// end of WebDocWf extension for save without references
	  // commit referenced DOs.
	  	org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO ENUMTYPEDEFINITIONOID_DO = getENUMTYPEDEFINITIONOID();
	if ( null != ENUMTYPEDEFINITIONOID_DO ) {
	    if ( ENUMTYPEDEFINITIONOID_DO.isLoaded() ) {
		okToCommitENUMTYPEDEFINITIONOID( ENUMTYPEDEFINITIONOID_DO );
		ENUMTYPEDEFINITIONOID_DO.commit( dbt );
	    } else {
		// since the referenced DO is not loaded,
		// it cannot be dirty, so there is no need to commit it.
	    }
	} else {
	    if ( ! false )
		throw new RefAssertionException(
		    "Cannot commit EnumValueDefinitionDO ( " + toString() +
		    " ) because ENUMTYPEDEFINITIONOID is not allowed to be null." );
	}

// WebDocWf extension for save without references
// The following line has been inserted
	  }
// end of WebDocWf extension for save without references
      }
      if ( false ) {
	  // This throw is here to keep the compiler happy
	  // in the case of a DO that does not refer to other DOs.
	  // In that case, the above delete/commit code blocks will be empty
	  // and throw nothing.
	  throw new DataObjectException( "foo" );	  
      }
      if ( delete ) {
          dbt.delete( this );
      } else {
	  if ( isLoaded() )
	      dbt.insert( this );   // dbt.insert() handles insertions and updates
      }
      if (ownTransaction) {
	  dbt.commit(); // commit the transaction
      }
    } catch (SQLException sqle) {
      StringBuffer message = new StringBuffer("Failed to insert/update DO: ");
      message.append(sqle.getMessage());

      // rollback, if necessary
      if (ownTransaction) {
        try {
          dbt.rollback();
        } catch (SQLException sqle2) {
          message.insert(0,"\n");
          message.insert(0,sqle2.getMessage());
          message.insert(0,"Rollback failed: ");
        }
      }
      throw new SQLException(message.toString());
    } finally {
      // release the transaction, if any
      if (ownTransaction) {
        dbt.release();
      }
    }
  }
}
