package org.enhydra.dods.generator;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

import org.enhydra.dods.Common;
import org.enhydra.dods.util.XmlUtil;
import org.enhydra.dods.util.XmlUtilException;
/**
 * Generate DODS-Ejen.properties file
 *
 * @author Nenad Vico
 * @version 1.0
 */

public class DODSEjenProperties {

    public static void main(String[] args) {

        try {
            Properties dodswizard = new Properties();
            dodswizard.setProperty("project.root",args[1]);
            dodswizard.setProperty("doml.file",args[0]);
            dodswizard.setProperty("doml.template",args[2]);
            dodswizard.setProperty("database.vendor",args[3]);
            dodswizard.setProperty("generate.force",args[4]);
            int l=0;
            int k=0;
            int last = 0;
            if (System.getProperty("os.name").toLowerCase().startsWith("win")) {
                l=args[0].lastIndexOf("/");
                k=args[0].lastIndexOf("\\");
                if(l>=k)
                    last = l;
                else
                    last=k; 
            } else
                last=args[0].lastIndexOf("/");
        
            dodswizard.setProperty("doml.filename",args[0].substring(last+1));
        
            File dodsEjenProperty = new File(Common.getDodsEjenPropertyFilename());
            dodsEjenProperty.getParentFile().mkdirs();
            dodswizard.store(new FileOutputStream(Common.getDodsEjenPropertyFilename()),"DODS Generator Wizard");

            Properties dodsProperties = new Properties();
            FileInputStream fisInstall = new FileInputStream(Common.getInstallProperties());
            dodsProperties.load(fisInstall);
            fisInstall.close();
            dodsProperties.setProperty("current.user.dir",System.getProperties().getProperty("user.home"));
            String templateDir = null;
            try {
                templateDir = XmlUtil.getSingleTextNode(Common.getDODSRoot()+File.separator+"build"+File.separator+"conf"+File.separator+"dodsConf.xml",
                                                               "/dodsConf/TemplateDir",null);
            } catch (XmlUtilException ex){
            }
                
            if (templateDir == null)
                templateDir = Common.getDODSRoot()+File.separator+"template";
            dodsProperties.setProperty("template.dir",templateDir);
            
            dodsProperties.store(new FileOutputStream(Common.getInstallProperties()),"DODS-EJEN INSTALL PROPERTIES");

        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
}