<?xml version="1.0" encoding="iso-8859-1"?>

<xsl:stylesheet version="1.0"
				xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xslt"
                xmlns:xalan-ext="http://xml.apache.org/xalan"
				xmlns:gvs="org.ejen.ext.GlobalVariables"
				xmlns:msg="org.ejen.ext.Messenger"
				xmlns:stu="org.ejen.ext.StringUtil"
				xmlns:xmi="org.ejen.ext.XMLInclude"
				xmlns:ver="org.ejen.ext.Version"
				xmlns:mta="org.ejen.ext.db.BasicMetaDataConnection"
				xmlns:common="org.enhydra.dods.Common"
                extension-element-prefixes="msg gvs mta xmi common"
                exclude-result-prefixes="xalan xalan-ext gvs msg mta stu ver xmi">

<xsl:output method="text" encoding="UTF-8"/> 
<!-- edited by Dragan Radeka 24.09.2002. -->
	
<xsl:template match ="/">
  <xsl:apply-templates />
</xsl:template>



<!-- DATABASE -->

<xsl:template match="DATABASE">
	<gvs:put name="targetName" select="''"/>

&lt;project name="generateJava" default="generate_all"&gt;
&lt;property name="doml.file" value="<xsl:value-of select="common:getDomlFile()"/>"/&gt;
&lt;property name="project.root" value="<xsl:value-of select="common:getProjectRoot()"/>"/&gt;
&lt;property name="template.dir" value="<xsl:value-of select="common:getTemplateDir()"/>"/&gt;
&lt;property name="template.set" value="<xsl:value-of select="common:getTemplateSet()"/>"/&gt;

	&lt;taskdef name="ejen" classname="org.ejen.EjenTask"/&gt;

	<xsl:for-each select="TABLE">
		&lt;target name="<xsl:value-of select="@id"/>"&gt;
		<xsl:if test="position()!=last()"><gvs:put name="targetName" select="concat(gvs:get('targetName'), @id, ', ')"/></xsl:if>
		<xsl:if test="position()=last()"><gvs:put name="targetName" select="concat(gvs:get('targetName'), @id)"/></xsl:if>
			&lt;ejen&gt;
				&lt;source file="<xsl:value-of select="common:getProjectRoot()"/>/<xsl:value-of select="@path"/>/<xsl:value-of select="@class"/>.xml"/&gt;
				&lt;template file="${template.dir}/${template.set}/Query/mainQUERY.xsl" outdated="true"
						  filepattern="<xsl:value-of select="common:getProjectRoot()"/>/<xsl:value-of select="@path"/>/<xsl:value-of select="@class"/>Query.java"&gt;
					&lt;include file="${template.dir}/${template.set}/Query/writeFileHeaderQuery.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/Query/writeMemberStuffQuery.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/Query/FK_setQuery_methodsHeaderQuery.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/Query/FK_setQuery_callsQuery.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/Query/FK_setQuery_methodsFooterQuery.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/Query/writeFileFooterQuery.xsl"/&gt;
				&lt;/template&gt;
				
				&lt;template file="${template.dir}/${template.set}/DOI/mainDOI.xsl" outdated="true"
						  filepattern="<xsl:value-of select="common:getProjectRoot()"/>/<xsl:value-of select="@path"/>/<xsl:value-of select="@class"/>DOI.java"&gt;
					&lt;include file="${template.dir}/${template.set}/DOI/writeFileHeaderDOI.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/DOI/writeMemberStuffDOI.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/DOI/writeFileFooterDOI.xsl"/&gt;
				&lt;/template&gt;
				
				&lt;template file="${template.dir}/${template.set}/DataStruct/mainDataStruct.xsl" outdated="true"
						  filepattern="<xsl:value-of select="common:getProjectRoot()"/>/<xsl:value-of select="@path"/>/<xsl:value-of select="@class"/>DataStruct.java"&gt;
					&lt;include file="${template.dir}/${template.set}/DataStruct/writeFileHeaderDataStruct.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/DataStruct/writeMemberStuffDataStruct.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/DataStruct/writeFileFooterDataStructBegin.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/DataStruct/cloningDataStruct.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/DataStruct/writeFileFooterDataStructEnd.xsl"/&gt;
				&lt;/template&gt;
				
				&lt;template file="${template.dir}/${template.set}/do/mainDO.xsl" outdated="true"
						  filepattern="<xsl:value-of select="common:getProjectRoot()"/>/<xsl:value-of select="@path"/>/<xsl:value-of select="@class"/>DO.java"&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileHeaderDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeMemberStuffDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writePreCompareCondDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeCompareCondDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO0.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/FK_get_set_methodsDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO1.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/ResultSetExtractionForLONG.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/ResultSetExtractionDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO2.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/HandleArrayDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO3.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/JDBCsetCallDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO4.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/JDBCsetCallForNonOidPKDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO5.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/JDBCsetCallForNonOidPKDO1.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO6.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/toStringDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO7.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/manyToOneReferrersDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/addReferrersDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/referrersDOInit.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/manyToManyReferrersDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO8.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/StubForCommitAssertionDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO9.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/CascadingDeletesDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO10.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/commitDeleteOtherDO.xsl"/&gt;
					&lt;include file="${template.dir}/${template.set}/do/writeFileFooterDO11.xsl"/&gt;
		  		&lt;/template&gt;
			&lt;/ejen&gt;
		&lt;/target&gt;
		</xsl:for-each>
		
		&lt;target name="generate_all" depends="<xsl:value-of select="gvs:get('targetName')"/>"&gt;
		&lt;/target&gt;

&lt;/project&gt;

</xsl:template>

</xsl:stylesheet>
