<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:miu="org.enhydra.dods.xslt.XSLTUtil"
                xmlns:common="org.enhydra.dods.Common"
                xmlns:dodst="org.enhydra.dods.xslt.DODSTag"
                version="1.0">

    <xsl:output method="text" encoding="iso-8859-1"/>
<xsl:template name="memberStuff">

    ////////////////////////// data member <xsl:value-of select="common:capitalizeName(@name)"/>
   <xsl:if test="not(IS_CONSTANT='true')">
    <xsl:if test="REFERENCE_OBJECT"><xsl:value-of select="dodst:addColumnName(@name,IS_PRIMARY_KEY,'true',USED_FOR_QUERY,REFERENCE_OBJECT/IS_FOREIGN_KEY,REFERENCE_OBJECT/IS_ABSTRACT)"/></xsl:if><xsl:if test="not(REFERENCE_OBJECT)"><xsl:value-of select="dodst:addColumnName(@name,IS_PRIMARY_KEY,'false',USED_FOR_QUERY,REFERENCE_OBJECT/IS_FOREIGN_KEY,REFERENCE_OBJECT/IS_ABSTRACT)"/></xsl:if>
    <xsl:value-of select="dodst:addFK(@name,REFERENCE_OBJECT/CONSTRAINT,REFERENCE_OBJECT/@name,REFERENCE_OBJECT/PACKAGE,REFERENCE_OBJECT/FOREIGN_KEY_COLUMN_NAME,REFERENCE_OBJECT/FOREIGN_KEY_GROUP)"/>

    /**
     * static final RDBColumn <xsl:value-of select="common:capitalizeName(@name)"/> for use with QueryBuilder.
     * See RDBColumn PrimaryKey at the top of this file for usage example.
     */
    static public final RDBColumn <xsl:value-of select="common:capitalizeName(@name)"/> = new RDBColumn( table, &quot;<xsl:value-of select="@name"/>&quot;, <xsl:if test="CAN_BE_NULL='false'">true</xsl:if><xsl:if test="CAN_BE_NULL='true'">false</xsl:if> );

    /**
     * Use for query caching.
     */
    static public final int COLUMN_<xsl:value-of select="common:upperCaseName(@name)"/> = <xsl:value-of select="dodst:getCounter()"/>;
    <xsl:value-of select="dodst:incCounter()"/>


<xsl:if test="IS_PRIMARY_KEY='true'">
    /*
     * <xsl:value-of select="/TABLE/CLASS_NAME"/>DO does not use OID as the Primary Key.
     * The data member <xsl:value-of select="@name"/> is a PK for <xsl:value-of select="/TABLE/CLASS_NAME"/>DO.
     * The "get" method(s) for the column(s) that comprise the PK
     * test isSet_ booleans to determine if the value has been set.
     * If not, an exception is thrown.
     * Since the getInsertStatement() and getUpdateStatement() methods
     * call the "get" methods, if this DO does not have its PK column(s) set,
     * it will not be written to the database.
     * (This test is not necessary for oid-based DOs because the CoreDO
     * constructor allocates a PK (oid) value.)
     */
    private boolean isSet_<xsl:value-of select="@name"/> = false;
</xsl:if>
    <xsl:text>    </xsl:text><xsl:value-of select="dodst:declMaxLength(@name,SIZE,DB_TYPE,JAVA_TYPE)"/>
</xsl:if>

    /**
     * Get <xsl:value-of select="@name"/> of the <xsl:value-of select="/TABLE/TABLE_NAME"/>.
     *
     * @return <xsl:value-of select="@name"/> of the <xsl:value-of select="/TABLE/TABLE_NAME"/>.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     */
    public <xsl:value-of select="miu:adjustJavaType(JAVA_TYPE)"/> get<xsl:value-of select="common:capitalizeName(@name)"/> ()
    throws DataObjectException {<xsl:if test="not(IS_CONSTANT='true')"><xsl:if test="/TABLE/DO_IS_OID_BASED='true'">
        checkLoad();</xsl:if><xsl:if test="IS_PRIMARY_KEY='true'">
        if ( ! isSet_<xsl:value-of select="@name"/> )
          throw new DataObjectException( &quot;Primary Key '<xsl:value-of select="@name"/>' unset.&quot; );</xsl:if></xsl:if>
        return data.<xsl:value-of select="@name"/>;
    }
   <xsl:if test="not(IS_CONSTANT='true')">
   <xsl:if test="IS_PRIMARY_KEY='true'">
    /**
     * Original value of <xsl:value-of select="@name"/> first retrieved from database.
     * This original value is set by createExisting(ResultSet).
     * It is used to construct the WHERE clause for UPDATEs,
     * in case a user-defined (non-oid) Primary Key value has changed.
     */
    private <xsl:value-of select="miu:adjustJavaType(JAVA_TYPE)"/> orig_<xsl:value-of select="@name"/> = <xsl:value-of select="miu:fixDefault(JAVA_TYPE,JAVA_DEFAULT_VALUE)"/>;
</xsl:if>
    /**
     * Set <xsl:value-of select="@name"/> of the <xsl:value-of select="/TABLE/TABLE_NAME"/>.
     *
     * @param <xsl:value-of select="@name"/> of the <xsl:value-of select="/TABLE/TABLE_NAME"/>.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     */
    public void set<xsl:value-of select="common:capitalizeName(@name)"/> ( <xsl:value-of select="miu:adjustJavaType(JAVA_TYPE)"/><xsl:text> </xsl:text><xsl:value-of select="@name"/> )
    throws DataObjectException {
<xsl:choose><xsl:when test="REFERENCE_OBJECT/IS_FOREIGN_KEY='true'">
      throw new DataObjectException( &quot;\nCalls to <xsl:value-of select="/TABLE/CLASS_NAME"/>DO.set<xsl:value-of select="common:capitalizeName(@name)"/>() are disallowed. &quot;+
                                     &quot;\n<xsl:value-of select="/TABLE/CLASS_NAME"/>DO.<xsl:value-of select="common:capitalizeName(@name)"/> is part of a &quot; +
                                     &quot;multicolumn foreign key. &quot; + &quot;\nTo ensure the foreign key is set completely, call &quot; +
                                     &quot;\n   <xsl:value-of select="/TABLE/CLASS_NAME"/>DO.<xsl:value-of select="SET_COMBO_FK_USING_DO_METHOD"/>()\n&quot; );
    </xsl:when><xsl:otherwise>        _set<xsl:value-of select="common:capitalizeName(@name)"/> ( <xsl:value-of select="@name"/> );</xsl:otherwise>
</xsl:choose>
    }

    /**
     * _set<xsl:value-of select="common:capitalizeName(@name)"/> is a protected method that is called by
     * set<xsl:value-of select="common:capitalizeName(@name)"/> if <xsl:value-of select="@name"/> is not part of
     * a multicolumn foreign key.
     *
     * @param <xsl:value-of select="@name"/> of the <xsl:value-of select="/TABLE/TABLE_NAME"/>.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     */
    protected void _set<xsl:value-of select="common:capitalizeName(@name)"/> ( <xsl:value-of select="miu:adjustJavaType(JAVA_TYPE)"/><xsl:text> </xsl:text><xsl:value-of select="@name"/> )
    throws DataObjectException {<xsl:if test="/TABLE/DO_IS_OID_BASED='true'">
        checkLoad();<xsl:if test="/TABLE/TEMPLATE_SET='multidb' or /TABLE/TEMPLATE_SET='multidb_webdocwf'"><xsl:if test="REFERENCE_OBJECT"><xsl:if test="REFERENCE_OBJECT/IS_FOREIGN_KEY='false'">
        if (!originDatabase.equals(<xsl:value-of select="@name"/>.getOriginDatabase()))
            throw new DataObjectException("Logical database of referenced object is different from DO's.");</xsl:if></xsl:if></xsl:if></xsl:if>
        data.<xsl:value-of select="@name"/> = <xsl:if test="REFERENCE_OBJECT"><xsl:if test="REFERENCE_OBJECT/IS_FOREIGN_KEY='false'">(<xsl:value-of select="miu:adjustJavaType(JAVA_TYPE)"/>)</xsl:if></xsl:if> markNewValue(data.<xsl:value-of select="@name"/>, <xsl:value-of select="@name"/><xsl:text> </xsl:text><xsl:value-of select="dodst:markNewValueExtras(@name,DB_TYPE,JAVA_TYPE,CAN_BE_NULL)"/> );<xsl:if test="IS_PRIMARY_KEY='true'">
        if ( ! isSet_<xsl:value-of select="@name"/> )
            orig_<xsl:value-of select="@name"/> = <xsl:value-of select="@name"/>;
        isSet_<xsl:value-of select="@name"/> = true;</xsl:if>
    }
</xsl:if>
</xsl:template>
</xsl:stylesheet>

